/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


#line 734 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    STATES = 373,
    FILTERS = 374,
    RECEIVE = 375,
    ACTION = 376,
    WARN = 377,
    BLOCK = 378,
    DISABLE = 379,
    KEEP = 380,
    FILTERED = 381,
    PASSWORD = 382,
    FROM = 383,
    PASSIVE = 384,
    TO = 385,
    EVENTS = 386,
    PACKETS = 387,
    PROTOCOLS = 388,
    INTERFACES = 389,
    ALGORITHM = 390,
    KEYED = 391,
    HMAC = 392,
    MD5 = 393,
    SHA1 = 394,
    SHA256 = 395,
    SHA384 = 396,
    SHA512 = 397,
    PRIMARY = 398,
    STATS = 399,
    COUNT = 400,
    FOR = 401,
    COMMANDS = 402,
    PREEXPORT = 403,
    NOEXPORT = 404,
    GENERATE = 405,
    ROA = 406,
    LISTEN = 407,
    BGP = 408,
    V6ONLY = 409,
    DUAL = 410,
    ADDRESS = 411,
    PASSWORDS = 412,
    DESCRIPTION = 413,
    SORTED = 414,
    RELOAD = 415,
    IN = 416,
    OUT = 417,
    MRTDUMP = 418,
    MESSAGES = 419,
    RESTRICT = 420,
    MEMORY = 421,
    IGP_METRIC = 422,
    CLASS = 423,
    DSCP = 424,
    WAIT = 425,
    MAX = 426,
    FLUSH = 427,
    AS = 428,
    SHOW = 429,
    STATUS = 430,
    SUMMARY = 431,
    ROUTE = 432,
    SYMBOLS = 433,
    ADD = 434,
    DELETE = 435,
    DUMP = 436,
    RESOURCES = 437,
    SOCKETS = 438,
    NEIGHBORS = 439,
    ATTRIBUTES = 440,
    EVAL = 441,
    ECHO = 442,
    ENABLE = 443,
    FUNCTION = 444,
    PRINT = 445,
    PRINTN = 446,
    UNSET = 447,
    RETURN = 448,
    ACCEPT = 449,
    REJECT = 450,
    QUITBIRD = 451,
    INT = 452,
    BOOL = 453,
    IP = 454,
    PREFIX = 455,
    PAIR = 456,
    QUAD = 457,
    EC = 458,
    LC = 459,
    SET = 460,
    STRING = 461,
    BGPMASK = 462,
    BGPPATH = 463,
    CLIST = 464,
    ECLIST = 465,
    LCLIST = 466,
    IF = 467,
    THEN = 468,
    ELSE = 469,
    CASE = 470,
    TRUE = 471,
    FALSE = 472,
    RT = 473,
    RO = 474,
    UNKNOWN = 475,
    GENERIC = 476,
    GW = 477,
    NET = 478,
    MASK = 479,
    PROTO = 480,
    SOURCE = 481,
    SCOPE = 482,
    CAST = 483,
    DEST = 484,
    IFNAME = 485,
    IFINDEX = 486,
    LEN = 487,
    DEFINED = 488,
    CONTAINS = 489,
    RESET = 490,
    PREPEND = 491,
    FIRST = 492,
    LAST = 493,
    LAST_NONAGGREGATED = 494,
    MATCH = 495,
    ROA_CHECK = 496,
    EMPTY = 497,
    WHERE = 498,
    BFD = 499,
    MIN = 500,
    IDLE = 501,
    RX = 502,
    TX = 503,
    INTERVAL = 504,
    MULTIPLIER = 505,
    MULTIHOP = 506,
    NEIGHBOR = 507,
    DEV = 508,
    LOCAL = 509,
    AUTHENTICATION = 510,
    SIMPLE = 511,
    METICULOUS = 512,
    SESSIONS = 513,
    HOLD = 514,
    CONNECT = 515,
    RETRY = 516,
    KEEPALIVE = 517,
    STARTUP = 518,
    VIA = 519,
    NEXT = 520,
    HOP = 521,
    SELF = 522,
    DEFAULT = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    LIVED = 571,
    STALE = 572,
    CEASE = 573,
    HIT = 574,
    ADMINISTRATIVE = 575,
    SHUTDOWN = 576,
    PEER = 577,
    CONFIGURATION = 578,
    CHANGE = 579,
    DECONFIGURED = 580,
    CONNECTION = 581,
    REJECTED = 582,
    COLLISION = 583,
    OF = 584,
    MRT = 585,
    FILENAME = 586,
    PERIOD = 587,
    ALWAYS = 588,
    OSPF = 589,
    AREA = 590,
    OSPF_METRIC1 = 591,
    OSPF_METRIC2 = 592,
    OSPF_TAG = 593,
    OSPF_ROUTER_ID = 594,
    RFC1583COMPAT = 595,
    STUB = 596,
    TICK = 597,
    COST = 598,
    COST2 = 599,
    RETRANSMIT = 600,
    HELLO = 601,
    TRANSMIT = 602,
    PRIORITY = 603,
    DEAD = 604,
    TYPE = 605,
    BROADCAST = 606,
    BCAST = 607,
    NONBROADCAST = 608,
    NBMA = 609,
    POINTOPOINT = 610,
    PTP = 611,
    POINTOMULTIPOINT = 612,
    PTMP = 613,
    STRICT = 614,
    CRYPTOGRAPHIC = 615,
    ELIGIBLE = 616,
    POLL = 617,
    NETWORKS = 618,
    HIDDEN = 619,
    VIRTUAL = 620,
    ONLY = 621,
    BUFFER = 622,
    LARGE = 623,
    NORMAL = 624,
    STUBNET = 625,
    TAG = 626,
    EXTERNAL = 627,
    LSADB = 628,
    ECMP = 629,
    WEIGHT = 630,
    NSSA = 631,
    TRANSLATOR = 632,
    STABILITY = 633,
    GLOBAL = 634,
    LSID = 635,
    INSTANCE = 636,
    REAL = 637,
    NETMASK = 638,
    LENGTH = 639,
    LSA = 640,
    SUPPRESSION = 641,
    TOPOLOGY = 642,
    STATE = 643,
    PIPE = 644,
    MODE = 645,
    OPAQUE = 646,
    TRANSPARENT = 647,
    RADV = 648,
    RA = 649,
    MANAGED = 650,
    OTHER = 651,
    CONFIG = 652,
    LINGER = 653,
    MTU = 654,
    REACHABLE = 655,
    RETRANS = 656,
    TIMER = 657,
    CURRENT = 658,
    VALID = 659,
    PREFERRED = 660,
    MULT = 661,
    LIFETIME = 662,
    SKIP = 663,
    ONLINK = 664,
    AUTONOMOUS = 665,
    RDNSS = 666,
    DNSSL = 667,
    NS = 668,
    DOMAIN = 669,
    TRIGGER = 670,
    SENSITIVE = 671,
    LOW = 672,
    MEDIUM = 673,
    HIGH = 674,
    PROPAGATE = 675,
    RA_PREFERENCE = 676,
    RA_LIFETIME = 677,
    RIP = 678,
    INFINITY = 679,
    UPDATE = 680,
    GARBAGE = 681,
    MULTICAST = 682,
    VERSION = 683,
    SPLIT = 684,
    HORIZON = 685,
    POISON = 686,
    REVERSE = 687,
    ZERO = 688,
    PLAINTEXT = 689,
    RIP_METRIC = 690,
    RIP_TAG = 691,
    STATIC = 692,
    PROHIBIT = 693,
    MULTIPATH = 694,
    BLACKHOLE = 695,
    UNREACHABLE = 696,
    BABEL = 697,
    RXCOST = 698,
    WIRED = 699,
    WIRELESS = 700,
    BABEL_METRIC = 701,
    ENTRIES = 702
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 663 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1252 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1269 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  75
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3963

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  469
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  326
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1110
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2110

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   702

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     460,   461,    29,    27,   465,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   462,   459,
      23,    22,    24,   466,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   467,     2,   468,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   463,     2,   464,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   882,   882,   883,   886,   888,   896,   905,   906,   907,
     914,   915,   916,   924,   925,   926,   927,   928,   929,   935,
     936,   943,   944,   948,   955,   956,   960,   964,   971,   979,
     980,   987,   988,   992,   993,   999,  1008,  1009,  1013,  1018,
    1019,  1023,  1024,  1028,  1029,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1047,  1048,  1058,  1059,  1060,  1061,
    1064,  1065,  1066,  1067,  1068,  1069,  1073,  1079,  1080,  1081,
    1082,  1090,  1093,  1100,  1103,  1106,  1109,  1113,  1114,  1118,
    1119,  1120,  1128,  1133,  1134,  1138,  1139,  1143,  1150,  1151,
    1152,  1164,  1169,  1173,  1187,  1188,  1202,  1203,  1207,  1208,
    1209,  1210,  1217,  1231,  1233,  1235,  1239,  1240,  1241,  1242,
    1247,  1253,  1254,  1258,  1266,  1270,  1272,  1278,  1279,  1286,
    1287,  1291,  1297,  1301,  1310,  1319,  1321,  1325,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1341,  1342,  1343,  1344,  1348,  1349,  1350,  1351,  1352,  1356,
    1362,  1366,  1374,  1375,  1383,  1391,  1392,  1393,  1397,  1398,
    1402,  1407,  1408,  1412,  1414,  1422,  1426,  1427,  1433,  1440,
    1441,  1442,  1443,  1447,  1455,  1461,  1462,  1463,  1467,  1468,
    1472,  1473,  1474,  1475,  1476,  1477,  1483,  1484,  1485,  1489,
    1490,  1494,  1495,  1501,  1502,  1505,  1507,  1511,  1512,  1516,
    1536,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1548,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1563,
    1566,  1569,  1572,  1576,  1577,  1580,  1583,  1587,  1591,  1596,
    1602,  1609,  1614,  1619,  1624,  1628,  1632,  1636,  1645,  1653,
    1657,  1664,  1665,  1666,  1671,  1675,  1682,  1689,  1693,  1701,
    1702,  1703,  1708,  1712,  1715,  1716,  1717,  1718,  1719,  1720,
    1721,  1726,  1731,  1739,  1746,  1753,  1761,  1763,  1765,  1767,
    1769,  1771,  1773,  1775,  1778,  1782,  1788,  1789,  1790,  1794,
    1795,  1801,  1803,  1805,  1807,  1809,  1811,  1815,  1819,  1822,
    1826,  1827,  1828,  1832,  1833,  1834,  1842,  1842,  1852,  1856,
    1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,
    1867,  1868,  1869,  1870,  1892,  1903,  1904,  1911,  1912,  1919,
    1928,  1932,  1936,  1957,  1958,  1962,  1974,  1974,  1990,  1991,
    1994,  1995,  1999,  2002,  2011,  2024,  2025,  2026,  2027,  2028,
    2032,  2040,  2041,  2042,  2043,  2044,  2048,  2051,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2065,  2066,  2067,
    2068,  2072,  2073,  2074,  2078,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2090,  2091,  2092,  2093,  2094,  2098,  2099,  2100,
    2101,  2102,  2106,  2107,  2111,  2112,  2116,  2123,  2124,  2125,
    2126,  2133,  2134,  2137,  2138,  2145,  2157,  2158,  2162,  2163,
    2167,  2168,  2169,  2170,  2171,  2172,  2176,  2177,  2178,  2182,
    2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,  2195,
    2196,  2197,  2198,  2208,  2212,  2234,  2246,  2247,  2248,  2249,
    2250,  2251,  2252,  2253,  2254,  2255,  2259,  2260,  2261,  2262,
    2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,
    2273,  2274,  2275,  2277,  2278,  2279,  2281,  2283,  2285,  2287,
    2288,  2289,  2290,  2291,  2292,  2302,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2311,  2312,  2315,  2337,  2338,  2339,  2340,
    2341,  2342,  2346,  2349,  2350,  2351,  2359,  2365,  2373,  2374,
    2378,  2383,  2391,  2399,  2404,  2408,  2414,  2418,  2423,  2424,
    2425,  2432,  2433,  2434,  2435,  2436,  2442,  2454,  2455,  2456,
    2457,  2460,  2462,  2466,  2470,  2484,  2504,  2505,  2506,  2507,
    2508,  2509,  2510,  2511,  2515,  2516,  2517,  2518,  2519,  2520,
    2523,  2525,  2528,  2530,  2534,  2537,  2542,  2543,  2544,  2548,
    2549,  2553,  2554,  2557,  2576,  2582,  2609,  2611,  2612,  2617,
    2618,  2622,  2623,  2627,  2628,  2629,  2630,  2631,  2632,  2633,
    2634,  2635,  2639,  2640,  2641,  2642,  2643,  2644,  2650,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,  2658,  2659,  2660,  2661,
    2662,  2663,  2664,  2665,  2666,  2667,  2668,  2669,  2670,  2671,
    2672,  2673,  2674,  2675,  2676,  2677,  2678,  2679,  2680,  2681,
    2682,  2683,  2684,  2685,  2686,  2687,  2688,  2689,  2695,  2696,
    2697,  2698,  2699,  2700,  2701,  2702,  2703,  2704,  2705,  2706,
    2707,  2708,  2709,  2710,  2711,  2712,  2713,  2714,  2725,  2731,
    2732,  2733,  2734,  2735,  2736,  2737,  2740,  2742,  2746,  2749,
    2753,  2754,  2755,  2756,  2757,  2758,  2765,  2775,  2776,  2780,
    2781,  2782,  2783,  2784,  2785,  2786,  2787,  2788,  2791,  2806,
    2809,  2811,  2815,  2816,  2817,  2818,  2819,  2820,  2821,  2822,
    2823,  2824,  2824,  2825,  2825,  2826,  2827,  2828,  2832,  2833,
    2837,  2845,  2847,  2851,  2852,  2853,  2857,  2858,  2861,  2863,
    2866,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,  2875,
    2876,  2879,  2899,  2900,  2901,  2902,  2903,  2904,  2905,  2906,
    2907,  2908,  2909,  2910,  2911,  2912,  2913,  2914,  2915,  2916,
    2917,  2918,  2919,  2920,  2921,  2922,  2923,  2924,  2925,  2926,
    2927,  2928,  2929,  2930,  2931,  2932,  2933,  2934,  2935,  2936,
    2937,  2940,  2942,  2945,  2947,  2956,  2958,  2959,  2962,  2964,
    2968,  2969,  2972,  2982,  3003,  3005,  3009,  3009,  3012,  3014,
    3017,  3019,  3023,  3028,  3031,  3034,  3039,  3042,  3047,  3050,
    3054,  3058,  3061,  3062,  3063,  3064,  3065,  3066,  3067,  3068,
    3074,  3081,  3082,  3083,  3088,  3089,  3095,  3105,  3106,  3107,
    3108,  3108,  3109,  3109,  3110,  3115,  3118,  3120,  3124,  3128,
    3151,  3152,  3153,  3154,  3155,  3156,  3157,  3158,  3159,  3160,
    3165,  3169,  3170,  3171,  3172,  3173,  3174,  3174,  3175,  3175,
    3176,  3177,  3181,  3182,  3183,  3186,  3224,  3226,  3229,  3231,
    3235,  3238,  3251,  3252,  3253,  3254,  3258,  3265,  3273,  3275,
    3278,  3280,  3284,  3288,  3298,  3303,  3304,  3305,  3309,  3321,
    3323,  3327,  3328,  3332,  3345,  3350,  3351,  3352,  3356,  3368,
    3370,  3374,  3375,  3380,  3381,  3385,  3386,  3393,  3406,  3407,
    3408,  3409,  3410,  3413,  3415,  3419,  3423,  3446,  3476,  3477,
    3478,  3479,  3480,  3481,  3482,  3486,  3487,  3488,  3489,  3490,
    3491,  3492,  3493,  3494,  3495,  3496,  3497,  3498,  3499,  3500,
    3501,  3502,  3503,  3507,  3508,  3509,  3510,  3513,  3515,  3518,
    3520,  3524,  3530,  3533,  3540,  3547,  3548,  3549,  3550,  3551,
    3554,  3564,  3573,  3577,  3583,  3584,  3588,  3593,  3599,  3602,
    3607,  3608,  3609,  3610,  3611,  3615,  3616,  3619,  3621,  3624,
    3626,  3630,  3636,  3643,  3644,  3647,  3649,  3653,  3657,  3670,
    3693,  3694,  3695,  3696,  3697,  3698,  3699,  3700,  3701,  3702,
    3703,  3704,  3707,  3709,  3712,  3714,  3719,  3724,  3727,  3730,
    3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,  3737,
    3737,  3737,  3737,  3737,  3737,  3737,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,
    3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3738,  3739,
    3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,
    3739,  3740,  3740,  3740,  3740,  3741,  3741,  3741,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,
    3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3742,  3743,
    3743,  3744,  3745,  3746,  3747,  3748,  3749,  3750,  3751,  3752,
    3753,  3754,  3755,  3755,  3755,  3755,  3755,  3755,  3755,  3755,
    3755
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "STATES",
  "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP",
  "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS",
  "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC", "MD5", "SHA1",
  "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT", "FOR",
  "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN", "BGP",
  "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT",
  "PATH", "START", "DELAY", "FORGET", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "AWARE", "LINK",
  "EXTENDED", "SETKEY", "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE",
  "HIT", "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RADV",
  "RA", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "INFINITY", "UPDATE", "GARBAGE",
  "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "BABEL", "RXCOST", "WIRED", "WIRELESS",
  "BABEL_METRIC", "ENTRIES", "';'", "'('", "')'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "definition", "expr", "expr_us", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text", "opttext", "text_or_none",
  "log_config", "syslog_name", "log_file", "log_mask", "log_mask_list",
  "log_cat", "mrtdump_base", "timeformat_which", "timeformat_spec",
  "timeformat_base", "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    59,
      40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1595

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1595)))

#define YYTABLE_NINF -489

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-489)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      78,  3503,   174,   908,   738,  1037,   188,   738,   738,   594,
     738,   301,    87,  1435,   156,   241,  1001,  2081,   128,   738,
     144, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,   395,   557,   317,
     832,   489,   357,   452,   387, -1595, -1595,   532,   473,   419,
     612,  2081,   581, -1595, -1595, -1595, -1595, -1595, -1595,   243,
     243, -1595, -1595, -1595, -1595,   171, -1595,  2663, -1595,   243,
    3419, -1595, -1595, -1595,   243, -1595,   243,  3198,   243, -1595,
     243,  2783,   243,  3435,   243, -1595,   243, -1595,   243,  3176,
     243, -1595, -1595, -1595,  1933,  3452, -1595, -1595, -1595,   208,
   -1595,   647,   683,   720,   647,   629, -1595,   723,   723,   738,
     738,   757,   266, -1595,   698,   805,   247, -1595,   837,   842,
   -1595, -1595,   510,   194,   151,   836,   -68,   330,   330,   873,
     903,   914,   940,   952,  1002,  1016,  1038,    41, -1595, -1595,
   -1595,   870,   598, -1595,   808,   106,    44,  2081, -1595,   605,
     616,   628, -1595, -1595,   637,   640,   644,  1343,   120, -1595,
   -1595, -1595, -1595, -1595,  2514, -1595,  2865, -1595, -1595,  1287,
    1092,   723, -1595,  1090, -1595, -1595,  1056, -1595, -1595,    10,
     191,   208,   362, -1595, -1595, -1595, -1595,   352,   672,   362,
     362,   972,   985,    98, -1595,  1154, -1595,   266,   739,  3703,
   -1595,  1084,  1218,   786,   787, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   789,   208,
     924,  1234,  1138,   362,   441, -1595,   783,   667,   443,  1187,
     443,   266, -1595,   798,   800,   797,   806,   -35,   934,   945,
    1182,   813,  1253,   993,   443,   441,  1210,  1195,   168,  1114,
     278,    84,   330,    67,  1208,   370,  1209,  1012,  1009,   424,
    1200,  1007,   591,   995,   992,   441,   990,   991,   994,   839,
     -47,  1213,   984,   987,   441,   332,   441, -1595,   847,   846,
     848,   927,   160,   441,  1198,   362,   441,  1199, -1595, -1595,
     859,   852, -1595,   867,  1233,   577, -1595,   872,   880,   882,
     883,  1003,   330,  1262, -1595,   896,  1400,   894,   901,  1279,
     441,  1292,   441,  1293,  1295,  1297,   362, -1595,   926,   938,
     941,  1307,   723, -1595,   951,   954, -1595, -1595,   910,  1383,
     629, -1595, -1595,  1396,   362,  1408, -1595,  1411,  1412,  1418,
    1419, -1595, -1595, -1595,    82,  1420,  1413,  1430, -1595, -1595,
    1024,  1431, -1595,  1432,   550, -1595, -1595,  3187,   777,   836,
   -1595,   836,   836, -1595,   571,   627,  1434,   836,   836,  1436,
     836,   836,   836, -1595, -1595,    33,  1264,  1266, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,    24, -1595,    41,  2081,
      41,    41,  1437, -1595,  1439,  1425,  1422,   179,  1428,    44,
      44,  1429,  1427,  2081,  2081,  2081,  2081,  2081,  1443, -1595,
   -1595,  1449, -1595,  1000,    96, -1595, -1595, -1595, -1595,  1122,
   -1595,  1451, -1595, -1595, -1595, -1595,   276,    37, -1595,   447,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,  2081,  2081,  2081,  2081,
    2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,  2081,
     718, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
     586, -1595, -1595,  1463,  1464,   845,  2081,   443, -1595, -1595,
    1287,  1011, -1595, -1595, -1595, -1595, -1595, -1595,   362,  2081,
   -1595, -1595, -1595, -1595,   362,  1030,  1034, -1595,   758, -1595,
   -1595,   362, -1595, -1595, -1595, -1595, -1595, -1595, -1595,  2081,
    1013,  3572, -1595,   398,  1020, -1595,  1008,  1461, -1595, -1595,
   -1595,   -84, -1595, -1595,   441, -1595, -1595,   160, -1595, -1595,
   -1595, -1595,   350,  1610, -1595,  1344,  2081, -1595, -1595,   350,
   -1595, -1595,   350, -1595, -1595, -1595, -1595, -1595, -1595,  1406,
    1421,     4,   441,    95, -1595,  1025,    46,  1041,  1043,   362,
     157,  1181,   441,  1329,   330,  1046,  1057, -1595,  1059,  1488,
     126,   362,  1331,   362,  1444,  1452,   362,  1453,   308,   362,
     362,   441,  1456,  1068,  1433,  1076,   441,  1087,   441,   268,
     441,  1234,   441,  1093,  1095,   441,   441,   441,  1098,  1365,
     441,  1100, -1595, -1595, -1595,   441, -1595, -1595,   441, -1595,
    1491,   362, -1595, -1595, -1595,  1542,  1104,  1105, -1595, -1595,
   -1595, -1595,   441, -1595,  1234, -1595, -1595,  1049, -1595,   330,
   -1595,  1290, -1595, -1595, -1595,  1107, -1595,   362, -1595,   362,
   -1595,   441,   441,   441, -1595, -1595, -1595, -1595,   362,   330,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   645, -1595,
   -1595,  1564, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,   658, -1595, -1595, -1595, -1595,  1565, -1595, -1595, -1595,
    1550, -1595, -1595,  1561,   330, -1595, -1595,  1558,  1562, -1595,
    1610, -1595, -1595, -1595, -1595,   330, -1595, -1595, -1595,  1566,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1580,
    1568,  1568,   381,   836,  1568,   836,  1568, -1595,  1568,  1568,
   -1595,  1568,  1568,  1568,   362,   330, -1595,  1571,  1579,  1581,
   -1595, -1595,  1152, -1595, -1595, -1595, -1595,   192, -1595,  1139,
   -1595,  1345,  1573, -1595, -1595, -1595, -1595,   297,   665,   691,
    1180,   779,   285, -1595,  2081, -1595,  2081,  1134,    15,  1140,
    1206,   135,   270, -1595, -1595, -1595,  1593,  1592, -1595,  2167,
    2167,  2167,  2291,  2291,  2167,  2167,  2167,  2167,  2167,   650,
     650,  1427,  1427, -1595,  1151, -1595, -1595, -1595, -1595, -1595,
    1287, -1595, -1595, -1595,  1128,  1610,   443, -1595,  2622, -1595,
     693, -1595, -1595,  1379,  1594, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1158, -1595,  1159,  1484, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,   227,  1160,  1157, -1595, -1595,   362, -1595, -1595,   330,
   -1595, -1595, -1595,  2874,  3572, -1595,   330, -1595,  1167, -1595,
    1599, -1595,  1163, -1595,  1498, -1595, -1595, -1595, -1595,   441,
    3703, -1595, -1595,  3271,   362,   362,  1551,  1555,  1174,   362,
    1175,  1179, -1595,   441,    52, -1595, -1595,  1183,  1184,  1186,
    1191,   441,  1196,   441,  1197, -1595, -1595, -1595,  1627, -1595,
     362,   362, -1595,  1203,   362,  1207,   362,   362,  1211,   362,
    1212,  1214,  1215,  1217,  1219,   362, -1595,   160, -1595,  1220,
   -1595,  1221,  1222,  1225,  1230,  1235,  1236,  1238, -1595, -1595,
    1239,  1241,  1242, -1595,   326,  1244, -1595,  2799, -1595, -1595,
     362, -1595,   737,  1248, -1595, -1595,  3024,  3285,  1249,  1254,
   -1595,  1488, -1595,   330,    -8,  1290,   244, -1595,  3499, -1595,
   -1595, -1595, -1595,  1585, -1595,    33, -1595, -1595, -1595,   910,
   -1595, -1595,    82, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595,  1654,  1662, -1595, -1595,   160, -1595,
   -1595,   160,  1653, -1595,   160,  1568,  1690,  1568,  1721,  1722,
    1723,  1724,  1725,  1727, -1595, -1595,  1553,  1554,    41, -1595,
    2081, -1595,  1706,  1707,  2081,  2081,  2081, -1595,  2081, -1595,
    2081,   809,   133,  1458,  2081,  1744,  2081, -1595, -1595,  2081,
   -1595, -1595,  1274,   870, -1595,  2081, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595,  1163, -1595, -1595, -1595,
   -1595,  3572,   807, -1595, -1595, -1595,  1281,  1280, -1595,  1560,
   -1595, -1595,  1096, -1595,   841, -1595, -1595, -1595, -1595,   330,
   -1595, -1595,  1284,  1282,  1285,   150,   362, -1595,  1286, -1595,
   -1595,  1294,   933, -1595,  1296, -1595, -1595, -1595, -1595,  1299,
   -1595,  1311, -1595, -1595,   203, -1595, -1595, -1595,  1316, -1595,
    1318,  1319, -1595,  1320, -1595, -1595, -1595, -1595, -1595,  1323,
    1325, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  1326, -1595,  1146,  1610,   443,   362,  1556,
   -1595, -1595, -1595,  1327, -1595, -1595,   441,   273,   386, -1595,
    1465,   330, -1595, -1595,   316, -1595,  1328, -1595,  1359, -1595,
   -1595,   330, -1595, -1595,   330,  1673, -1595, -1595,  1330, -1595,
     441,   362, -1595, -1595,  1332, -1595, -1595, -1595,  1488,   441,
     362,    -8,    14, -1595,  1734, -1595, -1595,  1333,  2081, -1595,
   -1595, -1595,  2081,  2081,   441, -1595,  2514,  1335,  1878, -1595,
   -1595, -1595, -1595, -1595,  1336,   362, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1787, -1595,  1795, -1595, -1595,
   -1595, -1595, -1595, -1595,  1785,  1786, -1595, -1595,  1774, -1595,
    1514,  2128,  2204,  2265,   856,  2081, -1595,  2081,   409,    22,
    3703,  1339,   497,     3,  1340,  1206,  1792,  2331, -1595,  1347,
      29, -1595,  3572, -1595,  1793,   330, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1351, -1595,    70, -1595, -1595,
     362, -1595,  1356,  1374,  1375, -1595, -1595,  1495,  1767, -1595,
     185,  1501,  1506,   831,   707, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1563, -1595, -1595, -1595, -1595,   362,   362,   441,   362,
   -1595,  1384,   160, -1595, -1595,  1385,  1390,   362, -1595, -1595,
     362,  1392, -1595, -1595, -1595,  1393, -1595,    23,    71, -1595,
     441, -1595, -1595, -1595,  1773, -1595, -1595, -1595, -1595, -1595,
    2081,  1425,  2081, -1595,  2648,  2970,   973,  1401,  1837,   436,
   -1595,  3703,  1397,  1402, -1595, -1595, -1595, -1595, -1595, -1595,
     698,   698,  1835, -1595, -1595, -1595, -1595,  2081,  2357,  2383,
   -1595,  1839,  2081, -1595,  1936, -1595,  1842,  2081,  1859,  2015,
    2058,  1409, -1595, -1595, -1595, -1595,  1688, -1595,  1163,  1351,
   -1595, -1595,  1855,   443,  1613,  1440, -1595, -1595, -1595,  1687,
    1557, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   933,   441,
    1163,  1426, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  1438, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1441,   362,  2674,  1423,  2705,
    2927, -1595,  1224, -1595, -1595,  2081,  2081,   782,  1878, -1595,
    1446,  1887,  1897, -1595,  2409, -1595, -1595,  1442,  1450,   526,
      26,  1454,   599,  1447,  1455,    27,  1459,    47, -1595,  1866,
   -1595,   703, -1595, -1595, -1595,   330,  1640, -1595, -1595, -1595,
   -1595, -1595,  1359, -1595, -1595,    39,   476,    50,   776, -1595,
   -1595,   602, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1460,   807,  1689, -1595,    34,  2749,  2786,  1457,  1462,
    1467,  1468,  1473, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1883,  2081, -1595, -1595, -1595,  1884,  2081, -1595,
    2081,  1912, -1595,  2081, -1595,  1477, -1595,   443,   441,  1474,
     925,  1664,   362,   362,   338, -1595, -1595, -1595,  1475,  1482,
   -1595,   441, -1595, -1595,  3386, -1595, -1595, -1595,   283,   441,
     362,   441, -1595,  1483, -1595,   362,   269,   362,   362,  1661,
     246, -1595, -1595,  1485,  2654, -1595,  1528,  1529,   441,   441,
     441, -1595,  1489,   184,   186,  2791, -1595,  1502,  1486,  1224,
      77, -1595, -1595, -1595,  1122, -1595, -1595,  1950, -1595, -1595,
   -1595, -1595,   286, -1595, -1595,  2081,  2081,  2081,  2081, -1595,
     595, -1595,  1499,  1508,  1509,  1511,  1512,  1507,  1513, -1595,
   -1595, -1595,  1840,  1717,  1729,  1730, -1595, -1595, -1595,  1050,
   -1595,  1834, -1595,  1137, -1595, -1595,  1659,   362,  1520,   441,
    1607,   274,   293,  1669,   441,  1596,   441,   362,   362,   362,
    1711,   362,   389,  1354,  1600,  1631,   362,  1611,  1637, -1595,
   -1595,  1541, -1595,   362,  1546, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,   362,   362, -1595, -1595,  1604,
     -11,    43,  -206,   -39,  1591,   441,  1606,  1939,  1603,  1735,
    1756,  1757, -1595,  1570,   362,   362, -1595, -1595, -1595, -1595,
     314,   330, -1595,  1577,   314,  2003, -1595,  1578,   362,   -52,
    1949,   362,   441,   330,   441,  1660,   464,   264,  1728,  1655,
     -71,  1964,  1972,   351,  1609,  1608, -1595, -1595,  1601, -1595,
   -1595, -1595, -1595,  2435,   224,    77,   322,  2461,  2487,  2527,
    2553,   362,  1732,  1674,   502,  1799,   731,  1803,   362, -1595,
    1620, -1595, -1595, -1595,  2081, -1595,  2081, -1595,  1602,  1621,
     362,   362,   362, -1595, -1595,  1062,   362,  2045,  2045,  1072,
     851,   897,  1617,   441, -1595, -1595, -1595,   193,   362,   362,
     362,   362, -1595, -1595, -1595, -1595,   533, -1595,  1670, -1595,
   -1595, -1595, -1595,   362, -1595,   362, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,   441,   441, -1595,   362,   441,
   -1595, -1595, -1595, -1595, -1595,  1810,   699,  1996,   362,  2007,
   -1595,   362,  1824,   699,   362,   362, -1595,   441,   362,   362,
    2020,   441,    23,   441,    71, -1595,  1665,  1665,   362, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   441,
     441,   362, -1595, -1595, -1595, -1595,   362,   362,   362, -1595,
   -1595, -1595, -1595, -1595, -1595,   588,   362, -1595, -1595,   362,
     362,   441, -1595,   441,   441, -1595, -1595,  2081, -1595, -1595,
   -1595,  1632,  1634,  1636,  1644, -1595,   441,   362,   362,   362,
   -1595,   362, -1595, -1595,   362, -1595, -1595,  1643,  1647, -1595,
    1840, -1595, -1595, -1595, -1595, -1595,  1656, -1595,  1657,  1658,
     784,   796,  1672,  2045,  2045,  2045,  2045, -1595, -1595,    54,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1737, -1595,   441,
   -1595, -1595, -1595, -1595, -1595, -1595,   362, -1595, -1595, -1595,
   -1595,   362,  1665,   362, -1595,   362, -1595,  1665, -1595, -1595,
   -1595, -1595,   362, -1595, -1595, -1595, -1595,   441, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  1741, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  2435, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595,  2081, -1595,  1137,
    1137,  1137, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  1137,  1675,  1683,  1684,  1685, -1595,  1747, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595,  1663, -1595, -1595, -1595, -1595,  1137,  1137,  1137,  1137,
   -1595,  1686,  2081, -1595, -1595, -1595, -1595, -1595,  1668, -1595
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   423,     0,     0,
       0,   986,   987,   988,   989,   990,   991,   992,   993,   994,
     995,   996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,
    1025,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,
    1035,  1036,  1037,  1038,     3,     1,     2,     0,     0,     0,
       0,     0,     0,     0,     0,   119,   120,     0,     0,     0,
       0,   423,     0,   970,   971,   972,   973,   974,   975,   121,
     121,   976,   977,   978,   979,   117,   980,     0,   982,   121,
     125,   983,   984,   985,   121,  1042,   121,   125,   121,  1044,
     121,   125,   121,   125,   121,  1047,   121,  1048,   121,   125,
     121,  1050,     5,   981,   125,   125,   290,   292,   291,     0,
      78,    77,     0,     0,    77,    79,    76,    34,    34,     0,
       0,     0,     0,   289,   261,   294,     0,   245,     0,     0,
     228,   253,     0,   224,     0,   224,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   405,   409,   418,
     415,   334,   425,   412,     0,     0,   408,   423,   456,     0,
       0,     0,   410,   411,     0,     0,     0,   423,     0,   413,
     414,   422,   454,   455,     0,   453,     0,   277,   276,     0,
     279,    34,   640,     0,    30,    29,    37,    40,    38,     0,
      18,     0,     0,    59,    58,    57,    56,     0,     0,     0,
       0,     0,   111,     0,   296,     0,   104,     0,     0,   298,
     326,   122,     0,     0,     0,   115,    82,    91,   168,   545,
     506,   628,   646,   780,   786,   867,   914,   942,     0,     0,
       0,     0,     0,     0,    18,   173,     0,     0,     0,     0,
       0,     0,  1041,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      18,     0,   546,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,  1043,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,  1045,   649,
       0,     0,   657,     0,     0,     0,  1046,     0,     0,     0,
       0,     0,     0,     0,  1049,     0,     0,   939,     0,     0,
      18,     0,    18,     0,     0,     0,     0,  1039,     0,     0,
       0,     0,    34,  1040,     0,     0,   176,   175,     0,     0,
      79,    73,    74,     0,    80,     0,    33,     0,     0,     0,
       0,   284,   187,   186,     0,     0,     0,     0,   293,   295,
     294,     0,   225,     0,   249,   220,   219,     0,     0,   224,
     223,   224,   224,   771,   224,   224,     0,   224,   224,     0,
     224,   224,   224,    19,    20,     0,     0,     0,   272,   268,
     273,   269,   266,   267,   270,   271,   405,   425,   405,   423,
     405,   405,     0,   396,     0,   423,     0,     0,     0,   408,
     408,     0,   451,   423,   423,   423,   423,   423,     0,   357,
     358,     0,   360,     0,     0,   335,   338,   336,   340,   423,
     337,   375,   372,   373,   374,   382,     0,   387,   391,     0,
    1089,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,
    1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,
    1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,
    1087,   426,  1088,   427,   428,   429,   430,   431,   432,   433,
     434,   435,  1091,  1094,  1093,  1090,  1092,  1095,  1096,  1097,
    1100,  1098,  1099,  1101,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1110,   457,   458,   274,   423,   423,   423,   423,
     423,   423,   423,   423,   423,   423,   423,   423,   423,   423,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       0,    43,   280,     0,     0,     0,   423,     0,    39,    41,
       0,     0,     7,     9,    14,    16,    15,    17,     0,   423,
      13,    67,   152,   153,    60,     0,     0,    66,     0,    69,
      70,     0,   112,   113,    98,   100,   101,   102,   164,   423,
       0,   315,   114,     0,     0,    55,     0,     0,   123,  1051,
    1055,     0,   169,   128,    18,   151,   137,     0,   126,   127,
     154,   142,     0,   315,   143,     0,   423,   130,   141,     0,
     131,   136,     0,   139,   129,   170,   171,   511,   562,     0,
       0,     0,    18,    18,   574,     0,     0,     0,     0,     0,
      18,     0,    18,     0,     0,     0,     0,   575,     0,    21,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,    18,     0,    18,     0,
      18,     0,    18,     0,     0,    18,    18,    18,     0,     0,
      18,     0,   563,   636,   647,    18,   658,   650,    18,   655,
     652,     0,   648,   660,   781,     0,     0,     0,   782,   796,
     873,   915,    18,   920,     0,   916,   931,     0,   930,     0,
     934,     0,   932,   933,   937,     0,   945,     0,    85,     0,
      87,    18,    18,    18,    95,  1053,  1054,  1052,     0,     0,
    1057,  1056,   181,   180,   182,   184,   185,   183,     0,   178,
     287,     0,    75,    81,    71,   283,   281,   285,   286,   191,
     192,     0,   189,   288,   262,   265,     0,   221,   226,   244,
       0,   251,   250,     0,     0,   227,   234,     0,     0,   242,
     315,   236,   235,   239,   240,     0,   241,   243,   229,     0,
     233,   252,   260,   254,   257,   258,   256,   259,   255,     0,
      32,    32,     0,   224,    32,   224,    32,   763,    32,    32,
     941,    32,    32,    32,     0,     0,    23,     0,     0,     0,
     400,   402,     0,   403,   404,   398,   386,   486,   489,     0,
     465,     0,     0,   466,   406,   407,   399,     0,     0,     0,
       0,     0,     0,   359,   423,   436,   423,     0,     0,     0,
     346,     0,     0,   416,   388,   389,     0,     0,   417,   448,
     446,   444,   441,   442,   443,   445,   447,   449,   450,   437,
     438,   439,   440,   459,     0,   460,   462,   463,   464,   278,
       0,   275,   282,   639,     0,   315,     0,   644,     0,    36,
       0,    35,    68,     0,     0,    62,    63,    64,    65,    10,
      11,    12,     0,   154,     0,     0,    96,   299,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,     0,     0,     0,   297,   319,     0,   108,   109,     0,
     103,   105,    54,     0,   315,   124,     0,   118,     0,   138,
     158,   161,   174,   150,   144,   133,   320,   321,   140,    18,
     322,   134,   132,   125,     0,     0,     0,     0,     0,     0,
       0,     0,   568,    18,    18,   605,   608,     0,     0,     0,
       0,    18,     0,    18,     0,   627,   626,   576,     0,   546,
       0,     0,   566,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   570,     0,   571,     0,
     603,     0,     0,     0,     0,     0,     0,     0,   582,   583,
       0,     0,     0,   610,     0,     0,   606,   125,   654,   651,
       0,   656,     0,     0,   784,   785,   125,   125,     0,     0,
     927,    21,   929,     0,   924,   928,   423,   919,   125,    94,
      86,    88,    89,    83,    92,    25,    24,    93,   177,     0,
      72,   188,     0,   222,   248,   247,   246,   231,   238,   232,
     230,   237,   544,    31,     0,     0,   770,   779,     0,   777,
     774,     0,     0,   772,     0,    32,     0,    32,     0,     0,
       0,     0,     0,     0,    26,    27,     0,     0,   405,   397,
     423,   475,     0,     0,   423,   423,   423,   452,   423,   473,
     423,     0,     0,   423,   423,   423,   423,   339,   334,   423,
     376,   383,     0,     0,   392,   423,    44,   642,   641,   643,
     645,     6,    42,     8,    61,   110,   165,    97,    99,   314,
     313,   315,   423,   107,   106,   324,   317,     0,   327,     0,
     172,   159,     0,   154,     0,   149,   135,   514,   514,     0,
     513,   507,     0,     0,     0,    18,     0,   625,     0,   618,
     617,     0,     0,   549,     0,   607,   611,   612,   613,     0,
     601,     0,   591,    22,     0,   547,   548,   564,     0,   572,
       0,     0,   595,     0,   578,   577,   590,   589,   584,     0,
       0,   604,   587,   579,   580,   581,   609,   623,   586,   585,
     624,   588,   615,     0,   614,     0,   315,     0,     0,     0,
     638,   629,   632,     0,   653,   753,    18,     0,    18,   671,
       0,     0,   673,   663,    18,   659,     0,   677,   754,   783,
     799,     0,   790,   792,     0,     0,   798,   787,     0,   876,
      18,     0,   875,   868,     0,   917,   918,   926,    21,    18,
       0,   925,     0,   479,     0,   480,   481,     0,   423,   477,
     478,   476,   423,   423,    18,   940,     0,     0,   423,   935,
     938,   948,   947,   943,     0,     0,    90,   179,   190,   765,
     764,   778,   773,   775,   776,     0,   766,     0,   768,   912,
     913,   967,   968,   969,     0,     0,   401,   487,     0,   467,
       0,     0,     0,     0,     0,   423,   419,   423,     0,     0,
     346,     0,     0,     0,     0,     0,     0,     0,   316,     0,
     423,   330,     0,   323,     0,   155,   156,   160,   162,   147,
     145,   146,   148,   154,   508,   532,   509,   536,   510,   512,
       0,   596,     0,     0,     0,   619,   598,     0,     0,   553,
       0,     0,     0,     0,     0,   551,   599,   600,   602,   567,
     565,   594,   593,   573,   592,   569,   616,   630,   631,   633,
     634,     0,   637,   154,   676,   664,     0,     0,    18,     0,
     662,     0,     0,   680,   675,   679,     0,     0,   669,   661,
       0,   687,   154,   788,   831,   840,   789,     0,     0,   794,
      18,   797,   154,   872,   869,   871,   874,   921,   923,   922,
     423,   423,   423,   423,     0,     0,     0,     0,     0,     0,
     499,   482,   484,     0,   154,   944,   946,    84,   767,   769,
     261,   261,     0,   472,   470,   471,   469,   423,     0,     0,
     355,     0,   423,   353,   423,   349,     0,   423,   347,   423,
     423,     0,   461,   325,   331,   318,     0,   157,   163,   532,
     530,   515,     0,     0,   539,     0,   621,   620,   622,     0,
       0,   557,   555,   556,   559,   558,   560,   550,     0,    18,
     756,   760,   666,   667,   665,   668,   741,   701,   681,   741,
     670,   755,   688,   828,   838,   837,   844,   843,   851,   791,
     853,   854,   861,   793,   795,   909,     0,     0,     0,     0,
       0,   493,   423,   393,   936,   423,   423,     0,   423,   498,
     964,     0,     0,   468,     0,   420,   421,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   390,     0,
     515,     0,   535,   537,   538,     0,   541,   597,   561,   554,
     552,   635,   754,   758,   762,     0,     0,     0,   690,   826,
     825,     0,   842,   849,   859,   907,   877,   870,   492,   424,
     496,     0,   423,   490,   332,     0,     0,     0,     0,     0,
       0,     0,     0,   485,   962,   949,   263,   264,   474,   370,
     354,   352,     0,   423,   350,   368,   348,     0,   423,   366,
     423,   364,   363,   423,   361,     0,   534,     0,    18,     0,
       0,     0,     0,     0,     0,   533,   523,   194,   198,     0,
     540,    18,   543,   757,     0,   672,   744,   742,   745,    18,
       0,    18,   678,     0,   674,     0,     0,     0,     0,     0,
       0,   686,   700,     0,     0,   830,     0,     0,    18,    18,
      18,   841,     0,   845,   855,     0,   911,     0,     0,   423,
     423,   341,   345,   343,   423,   500,   344,   380,   377,   378,
     379,   384,     0,   495,   494,   423,   423,   423,   423,   501,
     950,   966,     0,     0,     0,     0,     0,     0,     0,   116,
     199,   521,   195,     0,     0,     0,   516,   520,   524,     0,
     525,     0,   522,   200,   531,   542,     0,     0,     0,    18,
       0,     0,     0,     0,    18,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   761,
     740,     0,   746,     0,     0,   684,   685,   683,   682,   694,
     697,   698,   699,   692,   691,     0,     0,   695,   689,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
     816,   818,   829,     0,     0,     0,   832,   833,   834,   839,
       0,     0,   848,     0,     0,     0,   858,     0,     0,     0,
       0,     0,    18,     0,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   910,   902,     0,   497,
     333,   491,   395,   346,     0,   423,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   965,
       0,   369,   351,   367,   423,   365,   423,   362,     0,     0,
       0,     0,     0,   526,   527,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   706,   748,   738,     0,     0,     0,
       0,     0,   733,   727,   728,   729,    18,   739,     0,   722,
     702,   705,   703,     0,   720,     0,   707,   709,   710,   711,
     712,   713,   714,   715,   716,    18,    18,   704,     0,    18,
     759,   747,   743,   693,   696,     0,     0,     0,     0,     0,
     815,     0,     0,     0,     0,     0,   803,    18,     0,     0,
       0,    18,     0,    18,     0,   827,   865,   865,     0,   863,
     847,   846,   852,   850,   857,   856,   862,   860,   883,    18,
      18,     0,   878,   881,   882,   900,     0,     0,     0,   895,
     903,   906,   905,   904,   901,    18,     0,   880,   879,     0,
       0,    18,   884,    18,    18,   908,   342,   423,   381,   394,
     385,     0,     0,     0,     0,   951,    18,     0,     0,     0,
     959,     0,   955,   956,     0,   952,   963,     0,     0,   193,
     195,   517,   518,   519,   528,   529,     0,    28,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   197,   723,     0,
     731,   730,   732,   166,   167,   734,   735,     0,   736,    18,
     719,   708,   718,   721,   724,   717,     0,   822,   823,   824,
     812,     0,   865,     0,   802,     0,   811,   865,   805,   804,
     806,   807,     0,   820,   817,   821,   819,    18,   835,   836,
     864,   899,   888,   890,   893,   896,   894,     0,   897,   892,
     889,   891,   885,   886,   887,     0,   505,   503,   504,   502,
     961,   957,   960,   958,   953,   954,   356,   423,   196,   200,
     200,   200,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   200,     0,     0,     0,     0,   726,   750,   749,
     737,   725,   801,   814,   810,   813,   800,   809,   808,   866,
     898,     0,   207,   205,   206,   208,   200,   200,   200,   200,
     751,     0,   423,   201,   202,   203,   204,   752,     0,   371
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1595, -1595, -1595, -1595,   -82,  -228,    83,  -280,  -807,  -159,
    -771, -1595, -1093,   -86,   516,   385, -1595, -1595, -1595, -1595,
    1576,  1240, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,   863,  1751, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,  -319, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595,  3303,   -97,  1856, -1595,   396,  -491, -1595,
   -1595, -1595, -1595,   981,  -609,  -803, -1595, -1595, -1248, -1595,
   -1595, -1595, -1595,   198, -1595,  1083,   124, -1595,  1081, -1230,
     177, -1594, -1595,  -680, -1595, -1595, -1595, -1595, -1595,  -135,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
    -209, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1077,  1758, -1595, -1595, -1595,
   -1595,  -867,  1018,   838,  1567,  -584,  -376, -1595,  1228, -1595,
   -1595, -1493, -1595,   500,  -197,  1314,   363, -1087, -1464,  1969,
   -1463, -1370,  1317,   364, -1595, -1595,  -191,  1315, -1595, -1595,
   -1595, -1595,  -403,   785, -1595, -1595, -1030, -1595,  -172,   905,
     -17, -1595, -1595,   655,  1089,   763, -1021, -1595, -1595, -1595,
   -1595,  1033,   642, -1595, -1595, -1595,   726, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595,  1223, -1595, -1595,   708, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595,   709, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595,   635, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   306,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,   457,
     432, -1595, -1595, -1595, -1595,   307,   435, -1595, -1595, -1595,
   -1595,   313,   444, -1094, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
    1185, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595, -1595,
   -1595, -1595, -1595, -1595, -1595, -1166
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    94,   580,   589,   581,   415,   979,  1046,
    1047,   816,  1978,   218,  1064,   377,    95,   568,   219,   571,
     560,   561,    96,   227,   228,    97,    98,    21,    22,    23,
      24,    25,    26,   145,   375,    99,  1276,   358,   100,   364,
     359,   101,   600,   102,   603,   931,   103,   593,   104,   105,
     611,   106,   107,   243,   273,   627,  1145,   945,   616,   108,
     940,  1327,  1142,   941,  1458,  1459,   903,   904,  1852,   109,
     110,   620,   274,   369,   748,   749,   385,   761,   762,  1616,
    1828,  1617,  1618,  1842,  1982,    27,    28,    29,    30,   406,
      31,    32,    33,   397,   789,    34,   394,   774,    35,   398,
     387,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   210,   563,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   139,   391,   111,   601,   112,
     921,   922,   923,  1137,   947,   948,   628,   934,   925,   113,
     606,  1319,  1320,  1573,   199,   461,  1667,   848,   462,   849,
     463,   464,   465,  1671,   466,  1672,   200,   468,   469,  1575,
     431,   201,   432,   441,   202,   203,   204,  1267,   205,   533,
    1310,  1268,  1422,  1423,   828,   829,  1321,   114,  1152,   953,
     115,  1333,  1542,  1619,  1702,  1541,  1461,  1334,  1336,  1464,
    1546,  1622,  1338,    58,   116,   660,  1164,  1354,  1355,   117,
     118,  1213,  1017,   119,    59,   565,   120,   121,   330,   331,
     332,  1022,  1226,  1381,  1386,  1384,  1385,  1556,  1633,  1227,
    1558,  1643,  1228,  1731,  1555,  1627,  1628,  1734,  1989,  2101,
    2079,  1373,  1391,  1481,  1552,  1624,  1554,  1374,    60,    61,
      62,    63,    64,    65,    66,    67,   802,   122,   123,   124,
    1238,  1397,  1398,  1026,   125,  1392,  1763,  1902,  1904,  2010,
    1645,  1644,  1560,  1393,  1395,  1652,  1562,  1561,  1495,  1396,
    1498,  1563,  1773,  1912,  1653,  1499,  1502,  1564,  1777,  1916,
    1654,  1503,  1910,  2028,   126,  1244,  1027,   127,  1402,  1656,
    1798,  1934,  1655,  1566,  1403,    68,    69,   128,   129,   346,
    1034,  1035,   347,  1270,  1036,   725,    70,   130,  1274,  1038,
     131,  1424,  1681,  1820,  1680,  1585,  1425,    71,    72,    73,
     132,    74,   133,   134,   135,   534
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     206,   460,   590,   696,   238,   433,  1266,   467,   416,   417,
    1447,   942,   659,   662,  1060,  1269,  1309,  1311,  1313,  1314,
     318,   790,  1104,   820,   329,   821,   337,   823,   824,  1442,
     409,   819,   345,  1593,  1600,  -329,  1410,   360,   365,   426,
    1660,   413,   414,   427,  -329,  -329,  -329,  -329,  1252,  1661,
    1662,  1663,  1108,   428,  1603,   569,   426,   413,   414,   439,
     427,   413,   414,   814,   854,   855,  1136,   572,   413,   414,
     428,   573,   413,   414,   239,   683,  1891,   410,   936,  1658,
    1253,  1893,     1,  -328,   956,   413,   414,   574,   575,   576,
     577,  1500,  -328,  -328,  -328,  -328,  1252,   963,  1829,   572,
    1419,  1462,  1266,   573,   536,   537,   538,   539,   540,  1886,
     572,  1668,  1669,   594,   573,   595,   596,   597,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   411,  1253,   550,
     574,   575,   576,   577,   437,   455,   456,   457,   181,   458,
     583,   536,   537,   538,   539,   540,   639,   588,   588,  1254,
     455,   456,   457,  1108,   458,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   207,   572,   550,  1802,   980,   573,
     442,   959,   572,   208,    75,   594,   573,   595,   596,   597,
     454,   618,   631,   713,   633,   574,   575,   576,   577,   887,
    1006,   146,   574,   575,   576,   577,  1059,  1254,   647,  1892,
     536,   537,   538,   539,   540,  1670,   572,   831,   572,   658,
     573,   759,   573,   400,   541,   542,   543,   544,   545,   546,
     547,   548,   549,  1029,  1247,   550,   574,   575,   576,   577,
    1255,  1256,  1257,  1258,  1259,  1260,  1261,   598,   788,  1661,
    1662,  1663,  1108,   699,   366,   980,  1129,  1249,   640,   154,
     392,   661,  1262,   367,   433,  1263,   433,   760,   433,   433,
     578,   572,   241,  1252,   799,   573,   800,   801,   684,   804,
     806,  1919,   808,   809,   734,   811,   812,   813,  1255,  1256,
    1257,  1258,  1259,  1260,  1261,   455,   456,   457,  1108,   458,
    1266,  1937,   753,   572,  1126,  1253,   407,   573,   939,  1454,
    1262,  1119,   382,  1263,   153,   536,   537,   538,   539,   540,
     981,   383,  1949,   574,   575,   576,   577,   401,   167,   541,
     542,   543,   544,   545,   546,   547,   548,   549,  1642,   572,
     550,   572,   957,   573,  1463,   573,   212,  1661,  1662,  1663,
    1108,   572,  1668,  1669,  1571,   573,   408,   619,   413,   414,
     892,   574,   575,   576,   577,  1528,   651,  1530,   655,   438,
    1532,   604,  1535,  1537,  1254,   572,   572,  1938,   648,   573,
     573,  1326,   584,   656,   974,   964,  1829,   572,  1250,  1894,
     937,   573,   242,  1510,  1066,   220,   943,   981,   677,   402,
     412,  1930,  1920,  1118,  1730,   634,  1740,   688,  1887,   691,
    1067,   572,  1746,   168,   572,   573,   697,  1888,   573,   700,
     585,   586,   822,  1931,   213,   968,   969,   960,   827,   582,
    1853,   574,   575,   576,   577,  1797,   837,   838,   839,   840,
     841,  1471,   832,   728,   393,   730,  1670,  1031,   231,  1032,
     926,  1407,   850,  1130,   990,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,  1889,  1848,  1849,  1136,   572,   613,  1516,  1045,
     573,   221,   214,   215,  1448,  1698,   652,  1262,  1449,  1517,
    1263,   232,  1342,   570,  1411,   222,   574,   575,   576,   577,
    1105,   889,  1266,  1443,   429,  1699,  1496,  1594,  1601,  -329,
     430,  1574,   653,  -329,  1664,   815,   588,  1068,  1665,  1264,
     856,   429,   894,  1625,   233,  1045,  1683,   430,  1604,   902,
     440,  1685,   579,  1686,  1634,  1162,  1688,  1472,  2077,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   378,  1501,  1085,  1741,  -328,  1929,   229,
     944,  -328,  1266,   657,   579,  1865,  1002,   944,   572,   888,
     944,   234,   573,   769,  1457,   579,   230,   845,   599,   235,
    1854,   846,   893,   927,   928,   929,  1960,   967,   574,   575,
     576,   577,  1990,  1991,  1003,  1004,   214,   215,   403,   983,
     459,   985,   905,   236,   988,   982,   991,   992,   993,  1493,
     400,   209,   404,   405,  1306,  1109,   564,   689,  1307,  1505,
     240,   216,  1770,   572,  1774,  1700,  1701,   573,  1771,   950,
     579,  1775,   217,   136,   137,  1056,   803,   579,   690,  1021,
     599,  1520,  1368,   574,   575,   576,   577,  1376,  1377,  1266,
    1266,   214,   215,  1850,   245,  1932,   770,  1811,  1574,   138,
    1742,  1212,   664,  1848,  1849,  1039,   400,  1040,  1772,  1134,
    1776,   579,   665,   579,   460,   460,  1044,  1090,  1732,  1069,
    1378,  1812,  1359,  1629,  1855,  1733,   467,   140,  1075,  1851,
    1077,   368,   805,   536,   537,   538,   539,   540,  1190,   548,
     549,  1848,  1849,   550,  1947,  1296,   371,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   374,   938,   550,   536,
     537,   538,   539,   540,  1070,  1387,   579,   771,  1265,  1933,
     669,   670,   621,   541,   542,   543,   544,   545,   546,   547,
     548,   549,   772,   372,   550,   958,   961,  1071,  1941,   384,
     459,  1908,  1084,   970,   773,   972,   629,  1967,   579,  1968,
    1379,   852,  1072,   376,   853,  1979,  1099,   739,  1805,  1281,
    1100,  1806,  1282,  1248,   994,  1284,   237,   136,   137,   999,
     381,  1001,  1094,  1005,  1480,  1007,   149,   150,  1010,  1011,
    1012,  1073,  1074,  1015,   579,  1266,   579,  1139,  1018,   399,
     791,  1019,  1664,   138,   386,  1202,   579,   536,   537,   538,
     539,   540,  1997,   623,   624,  1028,   792,   899,   900,   901,
    1120,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     579,   579,   550,  2029,  1041,  1042,  1043,   536,   537,   538,
     539,   540,   579,  1927,   388,   389,  1252,  1101,   621,  1102,
    1630,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     395,  1607,   550,  1608,  1133,   396,   579,  2037,   883,   579,
     390,  1631,   622,  1813,  1814,   400,  1151,   930,  1253,  1928,
    1215,  1958,  1045,   793,   536,   537,   538,   539,   540,  1337,
    1440,  1609,  1153,  1154,  1441,   223,   418,  1158,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   673,   674,   550,
    2073,  2074,  2075,  2076,   224,   794,   795,  1959,  1175,  1176,
     434,   579,  1178,   796,  1180,  1181,   419,  1183,  1578,   623,
     624,    76,   857,  1189,  1607,   858,   433,   420,  2084,   625,
    1211,   626,  1329,  2087,  1216,   681,   682,  1254,   873,  1237,
    1243,   884,  1203,  2062,  2063,  2064,  2065,  2066,  1214,   797,
    1632,  1273,    77,   421,  1609,  2067,  2068,  2069,  2070,  2071,
     225,    78,  1815,   874,    79,   422,  1816,  1635,  1445,  1610,
    1611,   875,  1446,  1612,  1613,    80,   876,   877,   878,  1614,
    2091,   885,  1579,  1580,  1330,  1331,  1332,   798,    81,   706,
     707,   536,   537,   538,   539,   540,   886,  1591,    82,   742,
    1983,  1592,  1984,   579,    83,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   370,   423,   550,   373,  1255,  1256,
    1257,  1258,  1259,  1260,  1261,  2108,  1217,  1646,  1647,   424,
     226,  1648,  1649,  1650,    84,   951,    85,    86,   952,  1581,
    1262,  1817,  1146,  1263,    87,  1582,  1985,   626,  1986,   743,
     744,   425,  1636,   388,   389,  1045,  1161,  1163,   579,  1818,
     879,   880,   745,   746,  1169,   747,  1171,   140,   435,  1819,
    1596,   436,  1383,  1487,  1597,   443,  1651,   413,   414,  1030,
      88,    89,  1394,   827,  1344,  1399,   444,  1300,  1301,  1302,
     169,  1303,    90,  1304,   147,   148,   151,   152,   445,  1218,
     895,   896,  1315,   141,   897,   898,   211,   446,  1317,   626,
     447,   142,   143,   144,   448,    91,  1347,   562,    92,  1048,
    1049,  1219,   566,  1220,   413,   414,  1325,  1497,  1221,   567,
    1222,  1369,  1051,  1052,  1223,  1224,  1370,  2007,  2008,  2009,
    1095,   587,  1637,  1638,  1639,   177,  1640,   178,   179,   180,
     181,   182,   183,   170,  1348,   171,   172,   615,  1117,   184,
     185,   847,   186,   591,   187,   592,  1096,  1122,   880,  1405,
     536,   537,   538,   539,   540,   615,  1367,  1615,  1409,  1475,
    1476,  1477,  1478,   602,   541,   542,   543,   544,   545,   546,
     547,   548,   549,  1693,  1694,   550,  1962,  1963,   536,   537,
     538,   539,   540,  1427,   173,   174,   175,   176,   605,  1833,
    1834,  1225,   541,   542,   543,   544,   545,   546,   547,   548,
     549,  1974,  1975,   550,   536,   537,   538,   539,   540,  1980,
    1981,  1521,  1522,   607,   834,   835,   379,   380,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   608,  1343,   550,
    1641,  1414,   188,  1252,  1098,  1415,  1416,   614,   189,   609,
     610,  1421,   612,   615,  1836,   617,   632,   635,  1465,   636,
     637,   641,  1349,   643,  1350,  1620,  1351,  1352,   642,   638,
    1353,  -328,   644,   645,  1305,  1253,  1837,   646,  1838,   649,
     650,   654,   667,  1839,   663,   666,   668,   671,  1438,   672,
    1439,   675,   676,   678,  1482,  1483,   679,  1485,  1840,  1375,
     685,  1380,   686,   687,   680,  1490,   692,  1388,  1491,   693,
     695,   694,   190,   191,   698,   703,   701,  1065,   702,   705,
    1076,  1437,  1078,  1404,  1079,  1080,   712,  1081,  1082,  1083,
     704,   708,  1408,   551,   552,   553,   554,   555,   556,   557,
     558,   559,  1841,   709,  1254,   710,   711,  1417,   714,   192,
     193,   449,   450,   451,   452,   715,   177,   724,   178,   179,
     180,   181,   182,   183,   726,   727,   194,    93,   729,   195,
     184,   185,   731,   186,   196,   187,   732,  1544,  1666,  2092,
    2093,  2094,   733,   738,  1696,   735,   750,   536,   537,   538,
     539,   540,  2095,  1507,   827,  1509,  1626,   736,  1626,   752,
     737,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     740,   754,   550,   741,   755,   756,  2103,  2104,  2105,  2106,
    1524,   757,   758,   763,  1567,  1255,  1256,  1257,  1258,  1259,
    1260,  1261,   764,   765,   767,   768,  1513,   807,   177,   810,
     178,   179,   180,   181,   182,   183,   817,  1262,   818,   830,
    1263,   825,   184,   185,   826,   186,   833,   187,   851,   836,
     550,  1484,   842,   188,   843,   844,   881,   882,   933,   189,
     891,   177,   906,   178,   179,   180,   181,   182,   183,   932,
     935,   949,   954,  1504,   962,   184,   185,  1308,   186,   971,
     187,  1497,   536,   537,   538,   539,   540,   955,  1576,  1577,
     965,  1421,   966,  1924,   973,   975,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   984,   976,   550,   977,   978,
     986,  1690,   536,   537,   538,   539,   540,   996,   987,   989,
     588,  1697,   995,   190,   191,   998,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   188,  1000,   550,  1736,  1014,
     997,   189,  1008,  1739,  1009,  1743,  1744,  1013,  1747,  1016,
    1020,  1023,  1551,  1024,  1025,  1033,  1037,  1050,  1053,  1054,
     192,   193,   449,   450,   451,   452,  1055,  1057,   188,   155,
     156,  1058,   197,  1062,   189,  1061,  1086,   194,  1063,   198,
     195,  1285,  1394,  1287,  1087,   196,  1088,   157,  1092,  1103,
    1091,  1093,  1971,  1972,  1973,  1106,   716,  1666,  1112,  1666,
    1113,  1115,   158,  1089,  1124,   190,   191,  1125,  1127,  1131,
    1132,   159,  1497,   160,   161,  1844,  1140,  1141,  1143,   946,
    1144,  1156,  1155,  1157,  1159,  1860,  1861,  1862,  1160,  1864,
    1866,  1097,  1165,  1166,  1877,  1167,  1173,  1803,   190,   191,
    1168,  1881,   192,   193,  1275,  1170,  1172,  1279,  1807,  1808,
    1809,  1810,  1177,  1883,  1884,  1280,  1179,  1107,  1283,   194,
    1182,  1184,   195,  1185,  1186,   717,  1187,   196,  1188,  1191,
    1192,  1193,  1906,  1907,  1194,   192,   193,  1572,  1909,  1195,
     162,  1691,  1909,  1286,  1196,  1197,  1918,  1198,  1199,  1922,
    1200,  1201,   194,  1204,  1705,   195,   718,  1229,  1245,  2078,
     196,  1942,  1735,  1246,  1737,   719,  1867,  1868,  1869,  1870,
    1871,  1872,  1873,  1874,  1288,  1289,  1290,  1291,  1292,  1955,
    1293,  1766,  1767,  1768,  1298,  1299,  1965,  1294,  1295,  1316,
    1322,  1323,  1324,  1339,  1341,  1345,  1371,  1340,   588,   588,
     588,  1390,  1400,  1346,  1976,  1356,  1412,   177,  1357,   178,
     179,   180,   181,   182,   183,  1992,  1993,  1994,  1995,  1996,
    1358,   184,   185,  1312,   186,  1360,   187,  1361,  1362,  1363,
     163,  2000,  1364,  2001,  1365,  1366,  1372,  1389,  1382,  1401,
    1428,  1406,  1846,  1413,  1420,  1426,  2004,  1857,  1429,  1859,
    1430,  1431,  1432,   197,  1444,  1450,  2012,  1451,  1456,  2014,
     198,  1453,  2017,  2018,  1460,  1466,  2020,  2021,   907,   908,
     909,   910,   911,   912,   913,   914,  2030,   915,   916,   917,
     918,   919,   920,  1467,  1468,  1469,  1470,  1473,  1896,  2033,
    1123,  1474,  1506,  1479,  2034,  2035,  2036,  1486,  1488,   720,
     721,   722,   723,  1489,  2039,  1492,  1494,  2040,  2041,  1515,
    1514,  1519,  1518,  1523,   188,  1923,  1533,  1925,  1527,   164,
     189,  1531,  1539,  1538,  1543,  2051,  2052,  2053,  1545,  2054,
    1548,  1605,  2055,   165,  1569,   197,  -488,  1549,   166,  1553,
    1586,   177,   198,   178,   179,   180,   181,   182,   183,  1547,
    1587,  1559,  1621,  1589,  1565,   184,   185,  1598,   186,  1584,
     187,  1590,  1682,  1684,  1659,  1595,  1599,  1675,   197,  1687,
    1602,  1657,  1676,  1695,  2082,   198,  1988,  1677,  1678,  2083,
    2045,  2085,  1679,  2086,   190,   191,  1689,  1692,  1703,  1998,
    2088,  1704,  1738,  1745,  1748,  1128,  1764,  1765,  1769,   177,
    1800,   178,   179,   180,   181,   182,   183,  1804,  2002,  2003,
    1821,  1799,  2005,   184,   185,  1529,   186,  1826,   187,  1822,
    1823,   192,   193,  1825,  1827,  1433,  1824,  1830,  1607,   259,
    2019,  1835,  1843,  1845,  2023,  1847,  2025,  1856,   194,  1831,
    1832,   195,  1858,  1863,  1875,  1876,   196,  1878,   188,  1879,
    1880,  1895,  2031,  2032,   189,  1882,   349,   350,   351,  1885,
     352,   353,  1900,   354,  1897,  1898,  1899,   355,  2038,   261,
     356,  1901,  1903,  1500,  2042,  1921,  2043,  2044,   177,  1905,
     178,   179,   180,   181,   182,   183,  1913,  1917,  1926,  2050,
    1939,  1936,   184,   185,  1534,   186,  1935,   187,  1940,   262,
    1943,  1944,  1957,   263,   264,  1956,   188,   266,   267,  1961,
    1945,   268,   189,  1964,   269,  1977,  1969,  1999,   190,   191,
    2006,   177,  2011,   178,   179,   180,   181,   182,   183,  1966,
    1970,  1987,  2081,  2013,  2015,   184,   185,  1536,   186,  2022,
     187,  2046,  2027,  2047,   177,  2048,   178,   179,   180,   181,
     182,   183,   270,  2049,  2056,   192,   193,   271,   184,   185,
    2089,   186,  2057,   187,  2080,  2059,  2060,  2061,  2090,  2100,
    1116,   751,   194,   630,  1328,   195,   190,   191,  2102,  2109,
     196,  2072,  1277,  1278,  2096,   188,   536,   537,   538,   539,
     540,   189,  2097,  2098,  2099,  2107,   890,  2058,   766,  1318,
     541,   542,   543,   544,   545,   546,   547,   548,   549,  1801,
    1455,   550,  1138,   192,   193,  1110,   453,  1948,   924,  1111,
    1950,  1418,  1114,  1583,  1508,  -489,  -489,  -489,   188,  1297,
     194,  1335,  1606,   195,   189,  1540,  1550,  1623,   196,  -489,
    -489,  -489,  -489,  -489,   546,   547,   548,   549,  1557,  2016,
     550,   188,  1174,  1911,   197,   190,   191,   189,  1890,  2024,
    1915,   198,   536,   537,   538,   539,   540,  2026,  1914,     0,
    1251,     0,     0,     0,     0,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,     0,     0,
       0,     0,   192,   193,     0,     0,     0,     0,   190,   191,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   194,
       0,     0,   195,     0,     0,     0,     0,   196,     0,     0,
       0,   190,   191,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,   192,   193,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,     0,   550,   536,
     537,   538,   194,     0,     0,   195,     0,     0,   192,   193,
     196,     0,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   194,     0,     0,   195,     0,
       0,     0,     0,   196,     0,     0,     0,  -483,   197,   536,
     537,   538,   539,   540,     0,   198,     0,     0,     0,     0,
       0,     0,     0,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   536,   537,   538,   539,   540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,   536,   537,   538,   539,   540,   197,   357,     0,     0,
       0,     0,     0,   198,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,     0,   550,   536,   537,   538,
     539,   540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,     0,   550,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,     0,   550,   536,
     537,   538,   539,   540,     0,   197,     0,     0,     0,     0,
       0,     0,   198,   541,   542,   543,   544,   545,   546,   547,
     548,   549,     0,     0,   550,   536,   537,   538,   539,   540,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   197,   470,
     550,     0,     0,     0,     0,   198,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   536,   537,   538,   539,   540,
       0,   197,     0,     0,     0,     0,     0,     0,   198,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,   536,   537,   538,   539,   540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,     0,   550,     0,     0,  1434,
       0,     0,     0,     0,     0,     0,   471,   472,     0,     0,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     536,   537,   538,   539,   540,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   501,     0,   550,   536,   537,   538,   539,
     540,     0,     0,     0,     0,  1435,     0,     0,     0,     0,
     541,   542,   543,   544,   545,   546,   547,   548,   549,     0,
       0,   550,   536,   537,   538,   539,   540,     0,     0,     0,
       0,     0,   502,     0,     0,     0,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,     0,     0,
       0,     0,     0,   536,   537,   538,   539,   540,     0,     0,
       0,     0,     0,     0,     0,     0,  1436,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   246,     0,   550,     0,
       0,   247,     0,     0,     0,     0,     0,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,   536,   537,   538,
     539,   540,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,     0,   550,     0,     0,   248,     0,     0,     0,     0,
       0,     0,  1452,     0,   536,   537,   538,   539,   540,   512,
     513,   514,   515,   516,   517,   518,   519,   520,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,  1525,   550,
       0,     0,     0,     0,     0,   521,   522,   249,     0,   259,
       0,     0,     0,  1778,     0,     0,  1749,     0,     0,     0,
     523,     0,  1750,     0,  1526,   259,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1779,  1780,     0,
       0,   524,   525,   526,   527,  1751,     0,   321,   535,   261,
    1588,     0,     0,   536,   537,   538,   539,   540,  1781,     0,
       0,     0,     0,     0,     0,  1205,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,  1946,     0,   550,   262,
       0,     0,     0,   263,   264,     0,     0,   266,   267,     0,
    1752,   268,     0,     0,   269,   262,     0,     0,   250,   263,
     264,     0,  1951,   266,   267,  1206,     0,   268,     0,  1607,
     269,  1782,   470,  1753,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   528,   529,  1952,     0,
       0,     0,   270,     0,     0,     0,     0,   271,  1783,  1609,
     530,   531,     0,     0,     0,     0,     0,     0,   270,     0,
       0,   532,     0,   271,     0,     0,     0,  1754,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,  1953,     0,
       0,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,   251,     0,     0,     0,   252,   471,
     472,     0,     0,     0,  1954,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,   495,   496,   497,
     498,   499,   500,     0,     0,     0,  1784,     0,     0,  1785,
    1786,     0,     0,   626,     0,     0,     0,  1787,     0,     0,
    1755,  1756,     0,   253,     0,  1757,  1758,   254,  1759,     0,
     259,     0,     0,     0,     0,     0,  1760,  1761,     0,     0,
       0,  1121,   907,   908,   909,   910,   911,   912,   913,   914,
       0,   915,   916,   917,   918,   919,   920,   255,     0,     0,
       0,     0,     0,     0,     0,   502,     0,  1511,  1788,     0,
     261,   256,     0,     0,     0,     0,   257,     0,  1762,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   322,
       0,     0,     0,  1568,   323,   324,   325,     0,     0,     0,
     262,  1207,  1208,  1209,   263,   264,     0,  1230,   266,   267,
       0,     0,   268,     0,     0,   269,     0,     0,     0,     0,
       0,     0,     0,     0,  1570,     0,     0,     0,   326,     0,
       0,     0,     0,     0,     0,   327,  1789,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,  1790,   270,  1512,     0,     0,     0,   271,     0,
       0,     0,     0,     0,     0,   413,   414,     0,  1673,     0,
       0,     0,   512,   513,   514,   515,   516,   517,   518,   519,
     520,     0,   259,     0,     0,     0,     0,  1791,  1792,     0,
    1793,  1794,   776,  1795,     0,  1231,     0,     0,   521,   522,
       0,     0,   341,     0,   259,  1674,     0,   328,     0,   277,
       0,     0,     0,   523,     0,  1796,     0,     0,     0,   278,
       0,     0,   261,  1210,   279,     0,     0,     0,     0,     0,
       0,     0,     0,   777,   524,   525,   526,   527,   280,     0,
       0,     0,     0,     0,   261,     0,     0,     0,     0,     0,
       0,     0,   262,     0,     0,     0,   263,   264,     0,     0,
     266,   267,     0,     0,   268,   778,     0,   269,     0,     0,
       0,     0,   779,   780,   262,     0,     0,   259,   263,   264,
     281,   282,   266,   267,   781,     0,   268,     0,     0,   269,
       0,   259,     0,   283,     0,  1135,   284,     0,   285,     0,
       0,   782,   783,   784,   785,   270,   786,   787,     0,     0,
     271,     0,     0,     0,     0,     0,     0,   261,     0,   528,
     529,     0,     0,     0,   342,     0,     0,   270,     0,     0,
       0,   261,   271,   530,   531,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   532,     0,   286,   262,   287,     0,
       0,   263,   264,     0,  1147,   266,   267,   288,     0,   268,
       0,   262,   269,   244,     0,   263,   264,     0,  1239,   266,
     267,     0,   258,   268,     0,     0,   269,   275,     0,   276,
       0,   319,     0,   320,     0,   333,     0,   338,     0,   339,
       0,   340,     0,   348,     0,   289,     0,     0,     0,     0,
     270,   626,     0,     0,     0,   271,  1232,  1233,     0,     0,
    1234,     0,  1706,   290,   270,  1235,     0,     0,     0,   271,
     291,   292,     0,   293,     0,   259,     0,     0,   294,   295,
       0,   296,   297,     0,   298,     0,     0,   299,   300,   301,
       0,   259,     0,     0,     0,   260,     0,     0,  1236,   343,
       0,     0,   302,   303,     0,     0,     0,   304,   259,   305,
     306,     0,   307,     0,     0,   261,     0,   308,     0,     0,
       0,   309,   310,     0,   311,   312,     0,   313,   314,   315,
       0,   261,     0,   316,  1607,     0,     0,   361,     0,     0,
       0,     0,     0,  1148,  1149,   262,     0,     0,   261,   263,
     264,     0,   265,   266,   267,   259,     0,   268,     0,     4,
     269,   262,     0,     0,  1609,   263,   264,     0,     0,   266,
     267,     0,     0,   268,     0,     0,   269,  1707,   262,     0,
       0,     0,   263,   264,     5,     6,   266,   267,     0,     0,
     268,  1708,     0,   269,     7,   261,     0,     0,   270,     0,
       0,     0,     0,   271,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   270,     0,   362,     0,     0,   271,
       0,     0,     0,     0,     0,   262,     0,     0,     0,   263,
     264,   270,  1271,   266,   267,     0,   271,   268,     0,     0,
     269,     0,     0,     0,     0,     0,     0,     0,     8,     0,
     344,  1709,     0,     0,  1710,  1711,     0,     0,     0,     0,
       0,     0,  1712,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   317,     0,     0,     0,     0,     0,   270,     0,
    1240,     0,     0,   271,     9,     0,     0,    10,     0,    11,
       0,     0,     0,     0,     0,     0,    12,     0,    13,     0,
       0,     0,     0,    14,    15,    16,     0,     0,     0,     0,
      17,    18,    19,  1713,     0,     0,  1714,     0,     0,  1715,
       0,   536,   537,   538,   539,   540,     0,     0,     0,     0,
    1241,     0,     0,     0,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,  1150,   550,     0,  1716,     0,
    1717,     0,  1718,  1719,  1720,  1721,  1722,  1723,     0,  1242,
       0,     0,     0,  1724,     0,     0,  1725,     0,     0,  1726,
       0,     0,     0,     0,     0,     0,     0,     0,   334,     0,
       0,  1727,     0,     0,     0,     0,     0,     0,     0,  1728,
     907,   908,   909,   910,   911,   912,   913,   914,     0,   915,
     916,   917,   918,   919,   920,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   335,     0,     0,     0,
       0,     0,     0,     0,    20,     0,     0,     0,     0,     0,
    1729,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   272,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1272
};

static const yytype_int16 yycheck[] =
{
      17,   198,   230,   322,    90,   177,  1036,   198,   167,   168,
       7,   620,   292,   293,   785,  1036,  1103,  1104,  1105,  1106,
     117,   397,     7,   426,   121,   428,   123,   430,   431,     7,
     165,     7,   129,     7,     7,     6,    22,   134,   135,    15,
       6,    18,    19,    19,    15,    16,    17,    18,    19,    15,
      16,    17,    18,    29,     7,    45,    15,    18,    19,    15,
      19,    18,    19,    30,    27,    28,   933,    15,    18,    19,
      29,    19,    18,    19,    91,   122,   282,   145,   162,  1572,
      51,   120,     4,     6,    80,    18,    19,    35,    36,    37,
      38,    20,    15,    16,    17,    18,    19,    51,  1692,    15,
    1266,    31,  1132,    19,     8,     9,    10,    11,    12,   120,
      15,  1575,  1575,    15,    19,    17,    18,    19,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   195,    51,    33,
      35,    36,    37,    38,    28,    15,    16,    17,    18,    19,
     222,     8,     9,    10,    11,    12,   181,   229,   230,   120,
      15,    16,    17,    18,    19,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    36,    15,    33,  1660,    42,    19,
     187,    76,    15,    45,     0,    15,    19,    17,    18,    19,
     197,   263,   268,   342,   270,    35,    36,    37,    38,   565,
     681,     3,    35,    36,    37,    38,   780,   120,   284,   405,
       8,     9,    10,    11,    12,  1575,    15,    28,    15,   291,
      19,   129,    19,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   714,  1031,    33,    35,    36,    37,    38,
     201,   202,   203,   204,   205,   206,   207,   139,   397,    15,
      16,    17,    18,   325,    36,    42,    19,   255,   283,   162,
       3,   184,   223,    45,   426,   226,   428,   175,   430,   431,
      69,    15,    19,    19,   399,    19,   401,   402,   315,   404,
     405,   323,   407,   408,   356,   410,   411,   412,   201,   202,
     203,   204,   205,   206,   207,    15,    16,    17,    18,    19,
    1320,   362,   374,    15,   903,    51,   145,    19,   617,  1320,
     223,   885,    36,   226,     3,     8,     9,    10,    11,    12,
     184,    45,  1805,    35,    36,    37,    38,   123,   162,    22,
      23,    24,    25,    26,    27,    28,    29,    30,  1558,    15,
      33,    15,   328,    19,   264,    19,   192,    15,    16,    17,
      18,    15,  1806,  1806,  1510,    19,   195,   264,    18,    19,
     578,    35,    36,    37,    38,  1442,   188,  1444,    80,   253,
    1447,   237,  1449,  1450,   120,    15,    15,   438,   285,    19,
      19,  1142,    20,   290,   654,   329,  1970,    15,   386,   418,
     464,    19,   139,  1413,     3,    68,    36,   184,   305,   195,
     458,   127,   444,   884,  1624,   271,   127,   314,   409,   316,
      19,    15,   156,   162,    15,    19,   323,   418,    19,   326,
      58,    59,   429,   149,    19,   258,   259,   322,   435,   221,
     127,    35,    36,    37,    38,  1655,   443,   444,   445,   446,
     447,   246,   253,   350,   187,   352,  1806,   717,    81,   719,
      42,  1248,   459,   216,   136,   201,   202,   203,   204,   205,
     206,   207,   409,   179,   180,  1322,    15,   259,    22,   739,
      19,   144,    19,    20,   461,   127,   298,   223,   465,    33,
     226,    19,   322,   463,   460,   158,    35,    36,    37,    38,
     465,   567,  1512,   461,   460,   147,   463,   461,   461,   460,
     466,  1512,   324,   464,   460,   462,   578,   116,   464,   255,
     463,   460,   584,   464,   117,   785,  1593,   466,   461,   591,
     466,  1598,   460,  1600,   464,   463,  1603,   332,   464,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   148,   463,   815,   267,   460,  1786,    50,
     622,   464,  1572,   459,   460,   156,   278,   629,    15,   566,
     632,    19,    19,     3,  1325,   460,    67,   461,   460,    86,
     267,   465,   579,   165,   166,   167,  1814,   649,    35,    36,
      37,    38,   379,   380,   306,   307,    19,    20,   384,   661,
     460,   663,   599,   164,   666,   459,   278,   669,   670,  1392,
      19,   463,   398,   399,   461,   460,   211,   265,   465,  1402,
      19,    44,   418,    15,   418,   267,   268,    19,   424,   626,
     460,   425,    55,    19,    20,   774,    45,   460,   286,   701,
     460,  1424,  1206,    35,    36,    37,    38,   354,   355,  1659,
    1660,    19,    20,   359,   463,   371,    86,    42,  1659,    45,
     371,  1017,   272,   179,   180,   727,    19,   729,   464,   929,
     464,   460,   282,   460,   851,   852,   738,   465,   375,   278,
     387,    66,   459,   187,   371,   382,   857,    20,   803,   395,
     805,   463,    45,     8,     9,    10,    11,    12,   997,    29,
      30,   179,   180,    33,   460,  1088,     3,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    67,   614,    33,     8,
       9,    10,    11,    12,   323,   389,   460,   157,   464,   445,
     286,   287,    45,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   172,     3,    33,   642,   643,   346,   377,   463,
     460,   417,   814,   650,   184,   652,    69,  1824,   460,  1826,
     354,   465,   361,    20,   468,  1838,   461,   362,   462,  1068,
     465,   465,  1071,  1033,   671,  1074,   144,    19,    20,   676,
       3,   678,   465,   680,  1373,   682,   172,   173,   685,   686,
     687,   390,   391,   690,   460,  1805,   460,   936,   695,   269,
       3,   698,   460,    45,    86,   459,   460,     8,     9,    10,
      11,    12,   259,   126,   127,   712,    19,    39,    40,    41,
     886,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     460,   460,    33,  1907,   731,   732,   733,     8,     9,    10,
      11,    12,   460,   359,    19,    20,    19,   844,    45,   846,
     354,    22,    23,    24,    25,    26,    27,    28,    29,    30,
       3,   138,    33,   140,   926,     3,   460,   259,     3,   460,
      45,   375,    69,   258,   259,    19,   953,   459,    51,   395,
     123,   359,  1142,    86,     8,     9,    10,    11,    12,  1149,
     461,   168,   954,   955,   465,    43,     3,   959,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   296,   297,    33,
    1983,  1984,  1985,  1986,    62,   118,   119,   395,   980,   981,
      30,   460,   984,   126,   986,   987,     3,   989,   126,   126,
     127,     3,   465,   995,   138,   468,  1088,     3,  2012,   136,
    1017,   254,    81,  2017,   187,    86,    87,   120,   210,  1026,
    1027,    86,  1014,   149,   150,   151,   152,   153,  1020,   162,
     464,  1038,    34,     3,   168,   149,   150,   151,   152,   153,
     118,    43,   357,   235,    46,     3,   361,   181,   461,   256,
     257,   243,   465,   260,   261,    57,   248,   249,   250,   266,
    2057,   126,   190,   191,   133,   134,   135,   200,    70,   402,
     403,     8,     9,    10,    11,    12,   141,   461,    80,    79,
     139,   465,   141,   460,    86,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   141,     3,    33,   144,   201,   202,
     203,   204,   205,   206,   207,  2102,   279,   415,   416,     3,
     188,   419,   420,   421,   116,   629,   118,   119,   632,   247,
     223,   436,   949,   226,   126,   253,   139,   254,   141,   129,
     130,     3,   266,    19,    20,  1325,   963,   964,   460,   454,
     464,   465,   142,   143,   971,   145,   973,    20,   460,   464,
     461,   253,  1221,  1382,   465,   460,   464,    18,    19,    20,
     162,   163,  1231,  1090,  1156,  1234,   460,  1094,  1095,  1096,
      79,  1098,   174,  1100,     7,     8,     9,    10,   460,   352,
      60,    61,  1109,    56,    60,    61,    19,   460,  1115,   254,
     460,    64,    65,    66,   460,   197,   173,    15,   200,   464,
     465,   374,    22,   376,    18,    19,    20,  1397,   381,    63,
     383,  1207,   464,   465,   387,   388,  1208,   428,   429,   430,
     465,   459,   356,   357,   358,    13,   360,    15,    16,    17,
      18,    19,    20,   142,   211,   144,   145,    19,    20,    27,
      28,    29,    30,   181,    32,   170,   465,   464,   465,  1241,
       8,     9,    10,    11,    12,    19,    20,   464,  1250,   338,
     339,   464,   465,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   258,   259,    33,   455,   456,     8,     9,
      10,    11,    12,  1275,   193,   194,   195,   196,   459,   149,
     150,   464,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   149,   150,    33,     8,     9,    10,    11,    12,   147,
     148,  1430,  1431,   139,   439,   440,   149,   150,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    19,  1155,    33,
     464,  1258,   120,    19,   465,  1262,  1263,   323,   126,   463,
     463,  1268,   463,    19,   117,   117,    69,   459,  1340,   459,
     463,   327,   329,    81,   331,  1545,   333,   334,   323,   463,
     337,   464,   459,    20,   465,    51,   139,   284,   141,    69,
      85,   167,   270,   146,    76,    76,   277,    87,  1305,   282,
    1307,   296,   300,   303,  1376,  1377,   305,  1379,   161,  1216,
      87,  1218,   318,   316,   310,  1387,   459,  1224,  1390,   463,
     383,   463,   190,   191,   116,   463,   117,   801,   459,    86,
     804,   465,   806,  1240,   808,   809,   323,   811,   812,   813,
     463,   459,  1249,    46,    47,    48,    49,    50,    51,    52,
      53,    54,   205,   463,   120,   463,   463,  1264,    86,   227,
     228,   229,   230,   231,   232,   459,    13,   463,    15,    16,
      17,    18,    19,    20,   463,    86,   244,   459,    76,   247,
      27,    28,    79,    30,   252,    32,    81,  1463,  1575,  2059,
    2060,  2061,    85,    76,  1612,   459,     3,     8,     9,    10,
      11,    12,  2072,  1410,  1411,  1412,  1555,   459,  1557,     3,
     459,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     459,     3,    33,   459,     3,     3,  2096,  2097,  2098,  2099,
    1437,     3,     3,     3,  1506,   201,   202,   203,   204,   205,
     206,   207,    19,     3,     3,     3,   463,     3,    13,     3,
      15,    16,    17,    18,    19,    20,   182,   223,   182,    27,
     226,    14,    27,    28,    15,    30,    28,    32,     7,    30,
      33,  1378,    19,   120,    15,   465,     3,     3,   460,   126,
     459,    13,   459,    15,    16,    17,    18,    19,    20,   459,
      19,   137,    76,  1400,   459,    27,    28,    29,    30,   308,
      32,  1771,     8,     9,    10,    11,    12,    76,  1515,  1516,
     459,  1518,   459,  1783,   175,   459,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   184,   459,    33,   459,    31,
      76,  1607,     8,     9,    10,    11,    12,   459,    76,    76,
    1612,  1613,    76,   190,   191,   459,    22,    23,    24,    25,
      26,    27,    28,    29,    30,   120,   459,    33,  1630,   184,
     117,   126,   459,  1635,   459,  1637,  1638,   459,  1640,   459,
      69,    19,  1479,   459,   459,   275,   459,     3,     3,    19,
     227,   228,   229,   230,   231,   232,    15,    19,   120,   144,
     145,    19,   460,     3,   126,    19,    15,   244,    20,   467,
     247,  1075,  1751,  1077,    15,   252,    15,   162,   253,   465,
     461,    28,  1830,  1831,  1832,   465,   206,  1804,    15,  1806,
      18,   460,   177,   461,    20,   190,   191,   459,   459,   459,
     463,   186,  1902,   188,   189,  1707,   459,    28,   465,    19,
     132,    76,    81,   459,   459,  1717,  1718,  1719,   459,  1721,
    1722,   461,   459,   459,  1726,   459,    19,  1664,   190,   191,
     459,  1733,   227,   228,    69,   459,   459,     3,  1675,  1676,
    1677,  1678,   459,  1745,  1746,     3,   459,   461,    15,   244,
     459,   459,   247,   459,   459,   275,   459,   252,   459,   459,
     459,   459,  1764,  1765,   459,   227,   228,   463,  1770,   459,
     255,  1608,  1774,     3,   459,   459,  1778,   459,   459,  1781,
     459,   459,   244,   459,  1621,   247,   306,   459,   459,  1989,
     252,  1793,  1629,   459,  1631,   315,   362,   363,   364,   365,
     366,   367,   368,   369,     3,     3,     3,     3,     3,  1811,
       3,  1648,  1649,  1650,    28,    28,  1818,   184,   184,   465,
     459,   461,   182,   459,   459,   459,   190,   465,  1830,  1831,
    1832,   392,    79,   459,  1836,   459,    22,    13,   459,    15,
      16,    17,    18,    19,    20,  1847,  1848,  1849,  1850,  1851,
     459,    27,    28,    29,    30,   459,    32,   459,   459,   459,
     345,  1863,   459,  1865,   459,   459,   459,   459,   323,   459,
       3,   459,  1709,   460,   459,   459,  1878,  1714,     3,  1716,
      15,    15,    28,   460,   465,   465,  1888,    15,    15,  1891,
     467,   464,  1894,  1895,   463,   459,  1898,  1899,   208,   209,
     210,   211,   212,   213,   214,   215,  1908,   217,   218,   219,
     220,   221,   222,   459,   459,   340,    69,   336,  1755,  1921,
     461,   335,    69,   280,  1926,  1927,  1928,   463,   463,   449,
     450,   451,   452,   463,  1936,   463,   463,  1939,  1940,    22,
     459,   459,   465,    28,   120,  1782,     7,  1784,    29,   434,
     126,    29,   184,   464,    19,  1957,  1958,  1959,   265,  1961,
     193,    15,  1964,   448,   461,   460,   461,   330,   453,   463,
       3,    13,   467,    15,    16,    17,    18,    19,    20,   459,
       3,   463,   262,   461,   463,    27,    28,   460,    30,   463,
      32,   461,    29,    29,   225,   461,   461,   460,   460,     7,
     461,   461,   460,   259,  2006,   467,  1843,   460,   460,  2011,
    1947,  2013,   459,  2015,   190,   191,   459,   463,   463,  1856,
    2022,   459,   459,   282,   459,   461,   418,   418,   459,    13,
     464,    15,    16,    17,    18,    19,    20,     7,  1875,  1876,
     461,   459,  1879,    27,    28,    29,    30,   460,    32,   461,
     461,   227,   228,   461,   461,   461,   465,   260,   138,    46,
    1897,   147,   323,   463,  1901,   378,  1903,   318,   244,   260,
     260,   247,   396,   282,   394,   364,   252,   386,   120,   362,
     459,   410,  1919,  1920,   126,   459,    73,    74,    75,   405,
      77,    78,   277,    80,   408,    76,   413,    84,  1935,    86,
      87,   265,   265,    20,  1941,    76,  1943,  1944,    13,   459,
      15,    16,    17,    18,    19,    20,   459,   459,   378,  1956,
      76,   386,    27,    28,    29,    30,   318,    32,    76,   116,
     441,   443,   378,   120,   121,   323,   120,   124,   125,   260,
     459,   128,   126,   260,   131,    20,   464,   397,   190,   191,
     260,    13,    76,    15,    16,    17,    18,    19,    20,   459,
     459,   464,  1999,    76,   260,    27,    28,    29,    30,    69,
      32,   459,   427,   459,    13,   459,    15,    16,    17,    18,
      19,    20,   169,   459,   461,   227,   228,   174,    27,    28,
    2027,    30,   465,    32,   377,   459,   459,   459,   377,   372,
     880,   370,   244,   267,  1143,   247,   190,   191,   465,   461,
     252,   459,  1049,  1052,   459,   120,     8,     9,    10,    11,
      12,   126,   459,   459,   459,   459,   570,  1970,   390,  1131,
      22,    23,    24,    25,    26,    27,    28,    29,    30,  1659,
    1322,    33,   934,   227,   228,   851,   197,  1804,   601,   852,
    1806,  1266,   857,  1518,  1411,     8,     9,    10,   120,  1090,
     244,  1148,  1540,   247,   126,  1459,  1478,  1552,   252,    22,
      23,    24,    25,    26,    27,    28,    29,    30,  1489,  1893,
      33,   120,   979,  1771,   460,   190,   191,   126,  1751,  1902,
    1775,   467,     8,     9,    10,    11,    12,  1904,  1774,    -1,
    1035,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,   227,   228,    -1,    -1,    -1,    -1,   190,   191,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   244,
      -1,    -1,   247,    -1,    -1,    -1,    -1,   252,    -1,    -1,
      -1,   190,   191,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   227,   228,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,   244,    -1,    -1,   247,    -1,    -1,   227,   228,
     252,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,   244,    -1,    -1,   247,    -1,
      -1,    -1,    -1,   252,    -1,    -1,    -1,   459,   460,     8,
       9,    10,    11,    12,    -1,   467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,   460,   464,    -1,    -1,
      -1,    -1,    -1,   467,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,     8,
       9,    10,    11,    12,    -1,   460,    -1,    -1,    -1,    -1,
      -1,    -1,   467,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    -1,    33,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   460,     5,
      33,    -1,    -1,    -1,    -1,   467,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
      -1,   460,    -1,    -1,    -1,    -1,    -1,    -1,   467,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,   461,
      -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    -1,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   139,    -1,    33,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,   461,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      -1,    33,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,   178,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   461,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    73,    -1,    33,    -1,
      -1,    78,    -1,    -1,    -1,    -1,    -1,   233,   234,    -1,
     236,   237,   238,   239,   240,   241,   242,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,    -1,    -1,   122,    -1,    -1,    -1,    -1,
      -1,    -1,   461,    -1,     8,     9,    10,    11,    12,   285,
     286,   287,   288,   289,   290,   291,   292,   293,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,   461,    33,
      -1,    -1,    -1,    -1,    -1,   311,   312,   164,    -1,    46,
      -1,    -1,    -1,    42,    -1,    -1,   182,    -1,    -1,    -1,
     326,    -1,   188,    -1,   461,    46,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66,    67,    -1,
      -1,   347,   348,   349,   350,   211,    -1,    84,     3,    86,
     461,    -1,    -1,     8,     9,    10,    11,    12,    87,    -1,
      -1,    -1,    -1,    -1,    -1,    86,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   461,    -1,    33,   116,
      -1,    -1,    -1,   120,   121,    -1,    -1,   124,   125,    -1,
     256,   128,    -1,    -1,   131,   116,    -1,    -1,   255,   120,
     121,    -1,   461,   124,   125,   126,    -1,   128,    -1,   138,
     131,   140,     5,   279,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   432,   433,   461,    -1,
      -1,    -1,   169,    -1,    -1,    -1,    -1,   174,   167,   168,
     446,   447,    -1,    -1,    -1,    -1,    -1,    -1,   169,    -1,
      -1,   457,    -1,   174,    -1,    -1,    -1,   323,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,   461,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,   341,    -1,    -1,    -1,   345,    82,
      83,    -1,    -1,    -1,   461,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,    -1,    -1,    -1,   255,    -1,    -1,   258,
     259,    -1,    -1,   254,    -1,    -1,    -1,   266,    -1,    -1,
     406,   407,    -1,   400,    -1,   411,   412,   404,   414,    -1,
      46,    -1,    -1,    -1,    -1,    -1,   422,   423,    -1,    -1,
      -1,   459,   208,   209,   210,   211,   212,   213,   214,   215,
      -1,   217,   218,   219,   220,   221,   222,   434,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   178,    -1,   459,   317,    -1,
      86,   448,    -1,    -1,    -1,    -1,   453,    -1,   464,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   346,
      -1,    -1,    -1,   459,   351,   352,   353,    -1,    -1,    -1,
     116,   342,   343,   344,   120,   121,    -1,   123,   124,   125,
      -1,    -1,   128,    -1,    -1,   131,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   459,    -1,    -1,    -1,   385,    -1,
      -1,    -1,    -1,    -1,    -1,   392,   385,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,   401,   169,   224,    -1,    -1,    -1,   174,    -1,
      -1,    -1,    -1,    -1,    -1,    18,    19,    -1,   459,    -1,
      -1,    -1,   285,   286,   287,   288,   289,   290,   291,   292,
     293,    -1,    46,    -1,    -1,    -1,    -1,   436,   437,    -1,
     439,   440,    45,   442,    -1,   211,    -1,    -1,   311,   312,
      -1,    -1,    66,    -1,    46,   459,    -1,   464,    -1,    51,
      -1,    -1,    -1,   326,    -1,   464,    -1,    -1,    -1,    61,
      -1,    -1,    86,   464,    66,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    86,   347,   348,   349,   350,    80,    -1,
      -1,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   116,    -1,    -1,    -1,   120,   121,    -1,    -1,
     124,   125,    -1,    -1,   128,   118,    -1,   131,    -1,    -1,
      -1,    -1,   125,   126,   116,    -1,    -1,    46,   120,   121,
     122,   123,   124,   125,   137,    -1,   128,    -1,    -1,   131,
      -1,    46,    -1,   135,    -1,   461,   138,    -1,   140,    -1,
      -1,   154,   155,   156,   157,   169,   159,   160,    -1,    -1,
     174,    -1,    -1,    -1,    -1,    -1,    -1,    86,    -1,   432,
     433,    -1,    -1,    -1,   188,    -1,    -1,   169,    -1,    -1,
      -1,    86,   174,   446,   447,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   457,    -1,   188,   116,   190,    -1,
      -1,   120,   121,    -1,   123,   124,   125,   199,    -1,   128,
      -1,   116,   131,   100,    -1,   120,   121,    -1,   123,   124,
     125,    -1,   109,   128,    -1,    -1,   131,   114,    -1,   116,
      -1,   118,    -1,   120,    -1,   122,    -1,   124,    -1,   126,
      -1,   128,    -1,   130,    -1,   237,    -1,    -1,    -1,    -1,
     169,   254,    -1,    -1,    -1,   174,   422,   423,    -1,    -1,
     426,    -1,    66,   255,   169,   431,    -1,    -1,    -1,   174,
     262,   263,    -1,   265,    -1,    46,    -1,    -1,   270,   271,
      -1,   273,   274,    -1,   276,    -1,    -1,   279,   280,   281,
      -1,    46,    -1,    -1,    -1,    66,    -1,    -1,   464,   313,
      -1,    -1,   294,   295,    -1,    -1,    -1,   299,    46,   301,
     302,    -1,   304,    -1,    -1,    86,    -1,   309,    -1,    -1,
      -1,   313,   314,    -1,   316,   317,    -1,   319,   320,   321,
      -1,    86,    -1,   325,   138,    -1,    -1,    75,    -1,    -1,
      -1,    -1,    -1,   262,   263,   116,    -1,    -1,    86,   120,
     121,    -1,   123,   124,   125,    46,    -1,   128,    -1,    46,
     131,   116,    -1,    -1,   168,   120,   121,    -1,    -1,   124,
     125,    -1,    -1,   128,    -1,    -1,   131,   181,   116,    -1,
      -1,    -1,   120,   121,    71,    72,   124,   125,    -1,    -1,
     128,   195,    -1,   131,    81,    86,    -1,    -1,   169,    -1,
      -1,    -1,    -1,   174,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   169,    -1,   154,    -1,    -1,   174,
      -1,    -1,    -1,    -1,    -1,   116,    -1,    -1,    -1,   120,
     121,   169,   123,   124,   125,    -1,   174,   128,    -1,    -1,
     131,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   135,    -1,
     464,   255,    -1,    -1,   258,   259,    -1,    -1,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,   169,    -1,
     385,    -1,    -1,   174,   171,    -1,    -1,   174,    -1,   176,
      -1,    -1,    -1,    -1,    -1,    -1,   183,    -1,   185,    -1,
      -1,    -1,    -1,   190,   191,   192,    -1,    -1,    -1,    -1,
     197,   198,   199,   317,    -1,    -1,   320,    -1,    -1,   323,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
     435,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   464,    33,    -1,   352,    -1,
     354,    -1,   356,   357,   358,   359,   360,   361,    -1,   464,
      -1,    -1,    -1,   367,    -1,    -1,   370,    -1,    -1,   373,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   333,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,
     208,   209,   210,   211,   212,   213,   214,   215,    -1,   217,
     218,   219,   220,   221,   222,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   401,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   341,    -1,    -1,    -1,    -1,    -1,
     464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   464
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   470,   471,    46,    71,    72,    81,   135,   171,
     174,   176,   183,   185,   190,   191,   192,   197,   198,   199,
     341,   496,   497,   498,   499,   500,   501,   554,   555,   556,
     557,   559,   560,   561,   564,   567,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   662,   673,
     707,   708,   709,   710,   711,   712,   713,   714,   764,   765,
     775,   786,   787,   788,   790,     0,     3,    34,    43,    46,
      57,    70,    80,    86,   116,   118,   119,   126,   162,   163,
     174,   197,   200,   459,   472,   485,   491,   494,   495,   504,
     507,   510,   512,   515,   517,   518,   520,   521,   528,   538,
     539,   596,   598,   608,   646,   649,   663,   668,   669,   672,
     675,   676,   716,   717,   718,   723,   753,   756,   766,   767,
     776,   779,   789,   791,   792,   793,    19,    20,    45,   594,
      20,    56,    64,    65,    66,   502,     3,   594,   594,   172,
     173,   594,   594,     3,   162,   144,   145,   162,   177,   186,
     188,   189,   255,   345,   434,   448,   453,   162,   162,    79,
     142,   144,   145,   193,   194,   195,   196,    13,    15,    16,
      17,    18,    19,    20,    27,    28,    30,    32,   120,   126,
     190,   191,   227,   228,   244,   247,   252,   460,   467,   613,
     625,   630,   633,   634,   635,   637,   639,    36,    45,   463,
     583,   594,   192,    19,    19,    20,    44,    55,   482,   487,
      68,   144,   158,    43,    62,   118,   188,   492,   493,    50,
      67,    81,    19,   117,    19,    86,   164,   144,   482,   639,
      19,    19,   139,   522,   522,   463,    73,    78,   122,   164,
     255,   341,   345,   400,   404,   434,   448,   453,   522,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   131,
     169,   174,   464,   523,   541,   522,   522,    51,    61,    66,
      80,   122,   123,   135,   138,   140,   188,   190,   199,   237,
     255,   262,   263,   265,   270,   271,   273,   274,   276,   279,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   464,   523,   522,
     522,    84,   346,   351,   352,   353,   385,   392,   464,   523,
     677,   678,   679,   522,   333,   401,   464,   523,   522,   522,
     522,    66,   188,   313,   464,   523,   768,   771,   522,    73,
      74,    75,    77,    78,    80,    84,    87,   464,   506,   509,
     523,    75,   154,   464,   508,   523,    36,    45,   463,   542,
     502,     3,     3,   502,    67,   503,    20,   484,   484,   594,
     594,     3,    36,    45,   463,   545,    86,   569,    19,    20,
      45,   595,     3,   187,   565,     3,     3,   562,   568,   269,
      19,   123,   195,   384,   398,   399,   558,   145,   195,   558,
     145,   195,   458,    18,    19,   476,   478,   478,     3,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    29,   460,
     466,   629,   631,   637,    30,   460,   253,    28,   253,    15,
     466,   632,   639,   460,   460,   460,   460,   460,   460,   229,
     230,   231,   232,   618,   639,    15,    16,    17,    19,   460,
     613,   614,   617,   619,   620,   621,   623,   625,   626,   627,
       5,    82,    83,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   139,   178,   233,   234,   236,   237,   238,   239,   240,
     241,   242,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   311,   312,   326,   347,   348,   349,   350,   432,   433,
     446,   447,   457,   638,   794,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      33,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     489,   490,    15,   584,   484,   674,    22,    63,   486,    45,
     463,   488,    15,    19,    35,    36,    37,    38,    69,   460,
     473,   475,   542,   473,    20,    58,    59,   459,   473,   474,
     474,   181,   170,   516,    15,    17,    18,    19,   139,   460,
     511,   597,    19,   513,   545,   459,   609,   139,    19,   463,
     463,   519,   463,   542,   323,    19,   527,   117,   473,   475,
     540,    45,    69,   126,   127,   136,   254,   524,   605,    69,
     524,   482,    69,   482,   545,   459,   459,   463,   463,   181,
     283,   327,   323,    81,   459,    20,   284,   482,   475,    69,
      85,   188,   298,   324,   167,    80,   475,   459,   473,   476,
     664,   184,   476,    76,   272,   282,    76,   270,   277,   286,
     287,    87,   282,   296,   297,   296,   300,   475,   303,   305,
     310,    86,    87,   122,   315,    87,   318,   316,   475,   265,
     286,   475,   459,   463,   463,   383,   511,   475,   116,   473,
     475,   117,   459,   463,   463,    86,   402,   403,   459,   463,
     463,   463,   323,   478,    86,   459,   206,   275,   306,   315,
     449,   450,   451,   452,   463,   774,   463,    86,   475,    76,
     475,    79,    81,    85,   473,   459,   459,   459,    76,   484,
     459,   459,    79,   129,   130,   142,   143,   145,   543,   544,
       3,   503,     3,   473,     3,     3,     3,     3,     3,   129,
     175,   546,   547,     3,    19,     3,   595,     3,     3,     3,
      86,   157,   172,   184,   566,     3,    45,    86,   118,   125,
     126,   137,   154,   155,   156,   157,   159,   160,   478,   563,
     605,     3,    19,    86,   118,   119,   126,   162,   200,   558,
     558,   558,   715,    45,   558,    45,   558,     3,   558,   558,
       3,   558,   558,   558,    30,   462,   480,   182,   182,     7,
     631,   631,   639,   631,   631,    14,    15,   639,   643,   644,
      27,    28,   253,    28,   632,   632,    30,   639,   639,   639,
     639,   639,    19,    15,   465,   461,   465,    29,   616,   618,
     639,     7,   465,   468,    27,    28,   463,   465,   468,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   210,   235,   243,   248,   249,   250,   464,
     465,     3,     3,     3,    86,   126,   141,   605,   639,   482,
     489,   459,   474,   639,   473,    60,    61,    60,    61,    39,
      40,    41,   473,   535,   536,   639,   459,   208,   209,   210,
     211,   212,   213,   214,   215,   217,   218,   219,   220,   221,
     222,   599,   600,   601,   603,   607,    42,   165,   166,   167,
     459,   514,   459,   460,   606,    19,   162,   464,   475,   511,
     529,   532,   533,    36,   473,   526,    19,   603,   604,   137,
     639,   526,   526,   648,    76,    76,    80,   328,   475,    76,
     322,   475,   459,    51,   329,   459,   459,   473,   258,   259,
     475,   308,   475,   175,   476,   459,   459,   459,    31,   477,
      42,   184,   459,   473,   184,   473,    76,    76,   473,    76,
     136,   278,   473,   473,   475,    76,   459,   117,   459,   475,
     459,   475,   278,   306,   307,   475,   527,   475,   459,   459,
     475,   475,   475,   459,   184,   475,   459,   671,   475,   475,
      69,   473,   680,    19,   459,   459,   722,   755,   475,   527,
      20,   476,   476,   275,   769,   770,   773,   459,   778,   473,
     473,   475,   475,   475,   473,   476,   478,   479,   464,   465,
       3,   464,   465,     3,    19,    15,   478,    19,    19,   604,
     479,    19,     3,    20,   483,   483,     3,    19,   116,   278,
     323,   346,   361,   390,   391,   558,   483,   558,   483,   483,
     483,   483,   483,   483,   473,   476,    15,    15,    15,   461,
     465,   461,   253,    28,   465,   465,   465,   461,   465,   461,
     465,   639,   639,   465,     7,   465,   465,   461,    18,   460,
     614,   621,    15,    18,   626,   460,   490,    20,   527,   604,
     482,   459,   464,   461,    20,   459,   533,   459,   461,    19,
     216,   459,   463,   473,   476,   461,   600,   602,   607,   478,
     459,    28,   531,   465,   132,   525,   475,   123,   262,   263,
     464,   523,   647,   473,   473,    81,    76,   459,   473,   459,
     459,   475,   463,   475,   665,   459,   459,   459,   459,   475,
     459,   475,   459,    19,   664,   473,   473,   459,   473,   459,
     473,   473,   459,   473,   459,   459,   459,   459,   459,   473,
     511,   459,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   473,   459,    86,   126,   342,   343,   344,
     464,   523,   605,   670,   473,   123,   187,   279,   352,   374,
     376,   381,   383,   387,   388,   464,   681,   688,   691,   459,
     123,   211,   422,   423,   426,   431,   464,   523,   719,   123,
     385,   435,   464,   523,   754,   459,   459,   477,   476,   255,
     386,   769,    19,    51,   120,   201,   202,   203,   204,   205,
     206,   207,   223,   226,   255,   464,   635,   636,   640,   645,
     772,   123,   464,   523,   777,    69,   505,   544,   547,     3,
       3,   511,   511,    15,   511,   483,     3,   483,     3,     3,
       3,     3,     3,     3,   184,   184,   631,   643,    28,    28,
     639,   639,   639,   639,   639,   465,   461,   465,    29,   616,
     639,   616,    29,   616,   616,   639,   465,   639,   601,   610,
     611,   645,   459,   461,   182,    20,   479,   530,   532,    81,
     133,   134,   135,   650,   656,   650,   657,   476,   661,   459,
     465,   459,   322,   475,   473,   459,   459,   173,   211,   329,
     331,   333,   334,   337,   666,   667,   459,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,    20,   604,   482,
     473,   190,   459,   700,   706,   475,   354,   355,   387,   354,
     475,   682,   323,   478,   684,   685,   683,   389,   475,   459,
     392,   701,   724,   732,   478,   733,   738,   720,   721,   478,
      79,   459,   757,   763,   475,   473,   459,   477,   475,   473,
      22,   460,    22,   460,   639,   639,   639,   475,   638,   794,
     459,   639,   641,   642,   780,   785,   459,   473,     3,     3,
      15,    15,    28,   461,   461,   461,   461,   465,   639,   639,
     461,   465,     7,   461,   465,   461,   465,     7,   461,   465,
     465,    15,   461,   464,   645,   602,    15,   479,   533,   534,
     463,   655,    31,   264,   658,   473,   459,   459,   459,   340,
      69,   246,   332,   336,   335,   338,   339,   464,   465,   280,
     533,   702,   473,   473,   475,   473,   463,   511,   463,   463,
     473,   473,   463,   534,   463,   737,   463,   476,   739,   744,
      20,   463,   745,   750,   475,   534,    69,   639,   644,   639,
     635,   459,   224,   463,   459,    22,    22,    33,   465,   459,
     534,   569,   569,    28,   639,   461,   461,    29,   616,    29,
     616,    29,   616,     7,    29,   616,    29,   616,   464,   184,
     655,   654,   651,    19,   482,   265,   659,   459,   193,   330,
     667,   475,   703,   463,   705,   693,   686,   693,   689,   463,
     731,   736,   735,   740,   746,   463,   762,   473,   459,   461,
     459,   794,   463,   612,   645,   628,   639,   639,   126,   190,
     191,   247,   253,   642,   463,   784,     3,     3,   461,   461,
     461,   461,   465,     7,   461,   461,   461,   465,   460,   461,
       7,   461,   461,     7,   461,    15,   651,   138,   140,   168,
     256,   257,   260,   261,   266,   464,   548,   550,   551,   652,
     476,   262,   660,   701,   704,   464,   478,   694,   695,   187,
     354,   375,   464,   687,   464,   181,   266,   356,   357,   358,
     360,   464,   548,   690,   730,   729,   415,   416,   419,   420,
     421,   464,   734,   743,   749,   761,   758,   461,   610,   225,
       6,    15,    16,    17,   460,   464,   613,   615,   617,   619,
     620,   622,   624,   459,   459,   460,   460,   460,   460,   459,
     783,   781,    29,   616,    29,   616,   616,     7,   616,   459,
     482,   475,   463,   258,   259,   259,   474,   473,   127,   147,
     267,   268,   653,   463,   459,   475,    66,   181,   195,   255,
     258,   259,   266,   317,   320,   323,   352,   354,   356,   357,
     358,   359,   360,   361,   367,   370,   373,   385,   393,   464,
     548,   692,   375,   382,   696,   475,   473,   475,   459,   473,
     127,   267,   371,   473,   473,   282,   156,   473,   459,   182,
     188,   211,   256,   279,   323,   406,   407,   411,   412,   414,
     422,   423,   464,   725,   418,   418,   475,   475,   475,   459,
     418,   424,   464,   741,   418,   425,   464,   747,    42,    66,
      67,    87,   140,   167,   255,   258,   259,   266,   317,   385,
     401,   436,   437,   439,   440,   442,   464,   548,   759,   459,
     464,   612,   610,   639,     7,   462,   465,   639,   639,   639,
     639,    42,    66,   258,   259,   357,   361,   436,   454,   464,
     782,   461,   461,   461,   465,   461,   460,   461,   549,   550,
     260,   260,   260,   149,   150,   147,   117,   139,   141,   146,
     161,   205,   552,   323,   473,   463,   475,   378,   179,   180,
     359,   395,   537,   127,   267,   371,   318,   475,   396,   475,
     473,   473,   473,   282,   473,   156,   473,   362,   363,   364,
     365,   366,   367,   368,   369,   394,   364,   473,   386,   362,
     459,   473,   459,   473,   473,   405,   120,   409,   418,   409,
     738,   282,   405,   120,   418,   410,   475,   408,    76,   413,
     277,   265,   726,   265,   727,   459,   473,   473,   417,   473,
     751,   739,   742,   459,   751,   745,   748,   459,   473,   323,
     444,    76,   473,   475,   476,   475,   378,   359,   395,   537,
     127,   149,   371,   445,   760,   318,   386,   362,   438,    76,
      76,   377,   473,   441,   443,   459,   461,   460,   615,   610,
     622,   461,   461,   461,   461,   473,   323,   378,   359,   395,
     537,   260,   455,   456,   260,   473,   459,   616,   616,   464,
     459,   474,   474,   474,   149,   150,   473,    20,   481,   481,
     147,   148,   553,   139,   141,   139,   141,   464,   475,   697,
     379,   380,   473,   473,   473,   473,   473,   259,   475,   397,
     473,   473,   475,   475,   473,   475,   260,   428,   429,   430,
     728,    76,   473,    76,   473,   260,   728,   473,   473,   475,
     473,   473,    69,   475,   744,   475,   750,   427,   752,   752,
     473,   475,   475,   473,   473,   473,   473,   259,   475,   473,
     473,   473,   475,   475,   475,   639,   459,   459,   459,   459,
     475,   473,   473,   473,   473,   473,   461,   465,   549,   459,
     459,   459,   149,   150,   151,   152,   153,   149,   150,   151,
     152,   153,   459,   481,   481,   481,   481,   464,   476,   699,
     377,   475,   473,   473,   752,   473,   473,   752,   473,   475,
     377,   616,   552,   552,   552,   552,   459,   459,   459,   459,
     372,   698,   465,   552,   552,   552,   552,   459,   616,   461
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   469,   470,   470,   471,   471,   472,   473,   473,   473,
     474,   474,   474,   475,   475,   475,   475,   475,   475,   476,
     476,   477,   477,   478,   479,   479,   480,   480,   481,   482,
     482,   483,   483,   484,   484,   485,   486,   486,   487,   487,
     487,   488,   488,   489,   489,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   491,   491,   492,   492,   492,   492,
     493,   493,   493,   493,   493,   493,   494,   495,   495,   495,
     495,   496,   497,   498,   499,   500,   501,   502,   502,   503,
     503,   503,   504,   505,   505,   506,   506,   506,   506,   506,
     506,   507,   508,   508,   509,   509,   510,   510,   511,   511,
     511,   511,   511,   512,   513,   513,   514,   514,   514,   514,
     515,   516,   516,   517,   518,   519,   519,   520,   520,   521,
     521,   522,   522,   522,   522,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     524,   524,   524,   524,   525,   525,   525,   525,   525,   526,
     526,   527,   528,   528,   529,   530,   530,   530,   531,   531,
     532,   533,   533,   534,   535,   536,   537,   537,   538,   539,
     539,   539,   539,   540,   541,   542,   542,   542,   543,   543,
     544,   544,   544,   544,   544,   544,   545,   545,   545,   546,
     546,   547,   547,   548,   548,   549,   549,   550,   550,   551,
     552,   552,   552,   552,   552,   552,   552,   552,   552,   553,
     553,   553,   553,   553,   553,   553,   553,   553,   553,   554,
     555,   556,   557,   558,   558,   559,   560,   561,   562,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     562,   563,   563,   563,   564,   565,   565,   565,   565,   566,
     566,   566,   567,   568,   568,   568,   568,   568,   568,   568,
     568,   569,   569,   570,   571,   572,   573,   574,   575,   576,
     577,   578,   579,   580,   581,   582,   583,   583,   583,   584,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   594,   594,   595,   595,   595,   597,   596,   598,   599,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   600,   601,   601,   602,   602,   603,
     604,   604,   605,   606,   606,   607,   609,   608,   610,   610,
     611,   611,   612,   612,   613,   614,   614,   614,   614,   614,
     614,   615,   615,   615,   615,   615,   616,   617,   617,   617,
     617,   617,   617,   617,   617,   617,   617,   618,   618,   618,
     618,   619,   619,   619,   620,   620,   620,   620,   620,   620,
     620,   620,   621,   621,   621,   621,   621,   622,   622,   622,
     622,   622,   623,   623,   624,   624,   625,   626,   626,   626,
     626,   627,   627,   628,   628,   628,   629,   629,   630,   630,
     631,   631,   631,   631,   631,   631,   632,   632,   632,   633,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   634,
     634,   634,   634,   635,   636,   637,   638,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   640,   640,   640,   640,
     640,   640,   641,   642,   642,   642,   643,   643,   644,   644,
     645,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   646,   647,   647,   647,
     647,   648,   648,   649,   650,   651,   652,   652,   652,   652,
     652,   652,   652,   652,   653,   653,   653,   653,   653,   653,
     654,   654,   655,   655,   656,   657,   658,   658,   658,   659,
     659,   660,   660,   661,   662,   663,   664,   664,   664,   665,
     665,   666,   666,   667,   667,   667,   667,   667,   667,   667,
     667,   667,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   669,   670,
     670,   670,   670,   670,   670,   670,   671,   671,   672,   673,
     674,   674,   674,   674,   674,   674,   675,   676,   676,   677,
     677,   677,   677,   677,   677,   677,   677,   677,   678,   679,
     680,   680,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   682,   681,   683,   681,   681,   681,   681,   684,   684,
     685,   686,   686,   687,   687,   687,   688,   688,   689,   689,
     690,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   691,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   693,   693,   694,   695,   696,   696,   696,   697,   697,
     698,   698,   699,   700,   701,   701,   703,   702,   704,   704,
     705,   705,   706,   707,   708,   709,   710,   711,   712,   713,
     714,   715,   715,   715,   715,   715,   715,   715,   715,   715,
     716,   717,   717,   717,   717,   717,   718,   719,   719,   719,
     720,   719,   721,   719,   719,   719,   722,   722,   723,   724,
     725,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   726,   725,   727,   725,
     725,   725,   728,   728,   728,   729,   730,   730,   731,   731,
     732,   733,   734,   734,   734,   734,   734,   735,   736,   736,
     737,   737,   738,   739,   740,   741,   741,   741,   742,   743,
     743,   744,   744,   745,   746,   747,   747,   747,   748,   749,
     749,   750,   750,   751,   751,   752,   752,   753,   754,   754,
     754,   754,   754,   755,   755,   756,   757,   758,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   760,   760,   760,   760,   761,   761,   762,
     762,   763,   764,   765,   766,   767,   767,   767,   767,   767,
     768,   769,   769,   769,   770,   770,   771,   771,   771,   771,
     771,   771,   771,   771,   771,   772,   772,   773,   773,   774,
     774,   775,   776,   777,   777,   778,   778,   779,   780,   781,
     782,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   783,   783,   784,   784,   785,   786,   787,   788,
     789,   789,   789,   789,   789,   789,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   791,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   792,   792,   792,   792,   793,   793,   793,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     3,     2,
       2,     1,     1,     1,     0,     2,     2,     2,     2,     2,
       1,     1,     3,     3,     0,     1,     1,     2,     0,     1,
       3,     1,     3,     1,     0,     2,     2,     2,     2,     3,
       3,     3,     5,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     4,     4,     4,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     1,     4,     0,     3,     3,     3,     0,
       1,     1,     4,     0,     2,     2,     2,     2,     2,     2,
       2,     0,     2,     9,     9,     4,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     1,     1,     3,     0,
       1,     4,     4,     4,     3,     4,     4,     4,     4,     2,
       1,     1,     1,     1,     0,     1,     0,     4,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     2,     0,     3,     1,     3,     1,
       1,     1,     2,     3,     2,     4,     0,     5,     0,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     3,
       1,     1,     3,     1,     1,     1,     1,     5,     7,     5,
       7,     9,     7,     5,     7,     5,    11,     1,     1,     2,
       1,     7,     9,     7,     7,     9,     7,     9,     7,     9,
       7,    15,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     4,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     5,
       7,     7,     1,     0,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     3,     5,     7,     6,
       6,     6,     6,     4,     8,     4,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     3,     1,     3,     0,     1,
       4,     6,     4,     3,     5,     5,     4,     6,     3,     2,
       5,     5,     8,     8,     8,     8,     2,     1,     2,     2,
       2,     0,     3,     5,     0,     0,     2,     4,     4,     4,
       2,     2,     2,     1,     1,     1,     2,     2,     3,     3,
       0,     3,     0,     3,     4,     3,     0,     2,     2,     0,
       2,     0,     2,     4,     5,     2,     0,     3,     3,     1,
       3,     1,     3,     1,     3,     2,     2,     2,     2,     2,
       2,     3,     3,     3,     5,     6,     4,     6,     4,     6,
       4,     4,     5,     6,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     6,     5,     6,     8,     6,     6,
       6,     5,     6,     4,     5,     4,     4,     5,     4,     5,
       4,     5,     5,     5,     5,     5,     6,     5,     5,     6,
       7,     7,     7,     5,     5,     5,     4,     4,     2,     1,
       2,     2,     1,     2,     2,     4,     0,     3,     5,     4,
       0,     3,     3,     3,     2,     3,     2,     3,     3,     1,
       2,     3,     2,     4,     3,     2,     3,     1,     2,     4,
       0,     3,     2,     1,     2,     3,     3,     3,     3,     2,
       3,     0,     5,     0,     5,     2,     2,     1,     4,     1,
       1,     0,     3,     2,     2,     2,     5,     2,     0,     3,
       0,     2,     2,     3,     2,     2,     3,     2,     2,     2,
       1,     3,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       2,     3,     2,     3,     3,     4,     4,     2,     2,     2,
       3,     3,     3,     2,     3,     3,     3,     4,     2,     2,
       1,     0,     2,     3,     1,     0,     1,     2,     0,     2,
       0,     1,     3,     0,     0,     2,     0,     3,     0,     3,
       0,     3,     3,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     1,     2,     2,
       0,     3,     0,     3,     2,     3,     0,     3,     5,     0,
       4,     4,     3,     2,     3,     3,     3,     3,     4,     4,
       4,     3,     3,     4,     4,     2,     0,     3,     0,     3,
       3,     3,     1,     1,     1,     0,     0,     3,     0,     3,
       4,     1,     2,     2,     2,     4,     4,     0,     0,     3,
       0,     3,     3,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     0,     0,     2,     2,     0,     0,
       3,     1,     5,     1,     2,     0,     2,     2,     1,     2,
       4,     2,     2,     0,     3,     5,     0,     0,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     4,     3,
       2,     2,     1,     1,     1,     1,     1,     0,     3,     0,
       3,     4,     6,     6,     2,     3,     3,     5,     5,     4,
       2,     3,     3,     3,     1,     2,     4,     3,     3,     3,
       2,     2,     2,     2,     2,     1,     3,     0,     2,     0,
       3,     4,     2,     1,     2,     0,     3,     5,     0,     0,
       0,     2,     2,     3,     3,     2,     2,     3,     3,     2,
       3,     3,     0,     3,     0,     3,     4,     6,     6,     6,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     2,     1,     2,     2,     1,     1,     2,
       1,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 882 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4396 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 883 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 4402 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 896 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 906 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 907 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 914 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4433 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4439 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 916 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4445 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 926 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 927 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 928 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 929 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 936 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 4496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 948 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 956 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 960 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 964 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 971 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 980 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 988 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 992 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 993 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 999 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 1008 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 1009 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 4595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 1013 "cf-parse.y" /* yacc.c:1646  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = rf_file(f);
   }
#line 4605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 1018 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 1019 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 1023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 1024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 1028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 1029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 1033 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 1034 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 1035 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 1036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 1037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 1038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 1039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 1040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 1048 "cf-parse.y" /* yacc.c:1646  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
#line 4711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 1058 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4717 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 1059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4723 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 1060 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 1061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 1064 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4741 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 1065 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4747 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4753 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 1067 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4759 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 1068 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4765 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 1069 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4771 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 1079 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4777 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 1080 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4783 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 1081 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4789 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 1082 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4795 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 1091 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1094 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1101 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1104 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1107 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1110 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1120 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 1134 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1138 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1139 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1143 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1150 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1151 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1152 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1164 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1169 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1187 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1188 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1202 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1203 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1207 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1208 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1210 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 5014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1239 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 5020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1240 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 5026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1241 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 5032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1242 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 5038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1247 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 5044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1254 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 5056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1258 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 5066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 5074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 5082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 5088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 5094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1291 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 5105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1297 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 5114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1301 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1310 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1321 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 5149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1325 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 5155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1326 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 5161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1327 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 5167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1328 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 5173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1329 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 5179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1330 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 5185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1331 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 5191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1332 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 5197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 5203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1334 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); }
#line 5209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 5215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1336 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 5221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 5227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1341 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 5233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1343 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 5239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1344 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 5245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1348 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 5251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1349 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 5257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1350 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 5263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1351 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 5269 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1352 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 5275 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1356 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 5286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1362 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 5292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 1366 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 5301 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 1374 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 5307 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 1375 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1383 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1392 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1393 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1397 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 5347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1398 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 5353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1412 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1414 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5369 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1426 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5375 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1433 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5390 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1443 "cf-parse.y" /* yacc.c:1646  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5396 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1447 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1461 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1462 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1463 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1468 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 5436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1473 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 5442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1474 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 5448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 5454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1476 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 5460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1477 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 5466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1483 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1484 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1490 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 5496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1495 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 5502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1516 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 5530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1537 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1538 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1539 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1540 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1541 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1542 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1543 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1544 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1548 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_MD5; }
#line 5584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1549 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA1; }
#line 5590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA256; }
#line 5596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1551 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA384; }
#line 5602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1552 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_SHA512; }
#line 5608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1553 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1555 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1556 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5632 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1557 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5638 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1564 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 5644 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1567 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 5650 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1570 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1581 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 5674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 5680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1588 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 5686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1591 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5696 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1596 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1602 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5729 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1614 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1619 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1628 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1632 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1636 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1645 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1653 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1657 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1664 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1665 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1666 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1675 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1682 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1689 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1693 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1701 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1702 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1703 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1709 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1712 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1716 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1717 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1718 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1719 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1720 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1721 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1726 "cf-parse.y" /* yacc.c:1646  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1731 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1740 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1747 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 6000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1754 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 6009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1762 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 6015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1764 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 6021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1766 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 6027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1768 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 6033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1770 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 6039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1772 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 6045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 6051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1776 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 6057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1779 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 6063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 6072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1788 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 6078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1789 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1790 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 6090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1794 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 6096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1795 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 6105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1802 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1804 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1806 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1808 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 6129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 6135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1812 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 6141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1816 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 6147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1820 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 6153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1823 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 6159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1828 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1834 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 1842 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1843 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 6212 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1852 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 6218 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 6224 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1857 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 6230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 6236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 6242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 6248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1861 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 6254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1862 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 6260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LC; }
#line 6266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 6272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 6278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1866 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 6284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 6290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1868 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 6296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_LCLIST; }
#line 6302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1892 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 6345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1904 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1911 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1912 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6369 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1919 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1928 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1936 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1957 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1958 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 6424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1974 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1977 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1994 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1995 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1999 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2002 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 335:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 340:
#line 2032 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6547 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6553 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2048 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 2054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 2055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 2056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6625 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 2058 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 2059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 2061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 2065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 6649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 6655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 2068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 6667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 2072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 2073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 2074 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 2080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 2081 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 2083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 2084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 2086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 2093 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6739 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 2094 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 2101 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 2102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2112 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2123 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2124 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2125 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2133 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2134 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2137 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2138 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2145 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6847 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2158 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2162 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2163 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6871 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6877 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6883 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2169 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6889 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2170 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2171 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6901 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2172 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6907 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2182 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2183 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2184 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6943 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2185 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6949 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2186 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2187 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6961 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2188 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2189 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6973 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2190 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2191 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2195 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2196 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2197 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2198 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2234 "cf-parse.y" /* yacc.c:1646  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 7048 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 7054 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 7060 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 7066 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 7072 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 7078 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 7084 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2252 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 7090 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2253 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 7096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2254 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
#line 7102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2255 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 7108 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2259 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2260 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2261 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2262 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7132 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2263 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2264 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2265 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2267 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2268 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2269 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 7204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 7210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2277 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2278 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2279 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2281 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2283 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 7246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2287 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 7252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2289 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2290 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 463:
#line 2291 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 464:
#line 2292 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 465:
#line 2302 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 7288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 466:
#line 2303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 7294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 467:
#line 2304 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 7300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 468:
#line 2305 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 7306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 469:
#line 2306 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7318 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2309 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2311 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2312 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2315 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2337 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 7372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 477:
#line 2338 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 7378 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 478:
#line 2339 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 7384 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 479:
#line 2340 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 7390 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 2341 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 7396 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2342 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 7402 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2346 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2349 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2350 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2351 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2359 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2365 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7453 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2373 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 7459 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2374 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7465 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2391 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 2399 "cf-parse.y" /* yacc.c:1646  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 2418 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2423 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2424 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 500:
#line 2425 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2432 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2433 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2434 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2435 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2436 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2443 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 7616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2470 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2484 "cf-parse.y" /* yacc.c:1646  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7656 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7662 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2505 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2506 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2507 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2508 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2509 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2510 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2511 "cf-parse.y" /* yacc.c:1646  */
    {}
#line 7704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2515 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2516 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2518 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2519 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2538 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2542 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 7752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2543 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2544 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2548 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 7770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2549 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2558 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
#line 7844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7850 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7856 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7862 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7868 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2623 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 0; }
#line 7880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2628 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 1; }
#line 7886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 2; }
#line 7892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 2630 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 3; }
#line 7898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 4; }
#line 7904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 5; }
#line 7910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 6; }
#line 7916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 7; }
#line 7922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << 8; }
#line 7928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2644 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 2650 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 2651 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2652 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 7969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2654 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2655 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2656 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2657 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2658 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 8005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2659 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 8011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2660 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 8017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2661 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 8023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 8029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 8035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 8041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 2665 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 8047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 2666 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 8053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 2667 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 8059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 2668 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 8065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 2669 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2670 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 8077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 2671 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 2672 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 8089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2673 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 8095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2674 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 8101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2675 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2676 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2677 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 8119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 2678 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 8125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 2679 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 8131 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 598:
#line 2680 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 8137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2681 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 8143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2682 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 8149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2683 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 8155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2684 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 8161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 8167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2686 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 8173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2687 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 8179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2688 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 8185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 8196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2695 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 8202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2696 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 8208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2697 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 8214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2698 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 8220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2699 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 8226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2700 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 8232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2701 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 8238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2702 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 8244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2703 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 8250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2704 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 8256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2705 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 8262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2706 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 8268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2707 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 8274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2708 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 8280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2709 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 8286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2710 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 8292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2711 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 8298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2712 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 8304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2713 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
#line 8316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2726 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 8324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2732 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 8330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2734 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2735 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->filename = (yyvsp[0].t); }
#line 8348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 2736 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->period = (yyvsp[0].i); }
#line 8354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2737 "cf-parse.y" /* yacc.c:1646  */
    { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 8360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2746 "cf-parse.y" /* yacc.c:1646  */
    { mrt_check_config(this_proto); }
#line 8366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2750 "cf-parse.y" /* yacc.c:1646  */
    { mrt_dump_cmd((yyvsp[-1].md)); }
#line 8372 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 8378 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2754 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 8384 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 8390 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2756 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8396 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8402 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 8408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 8420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 2781 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 8426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 2782 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2783 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 2784 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2785 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2786 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 2787 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2791 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 8486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 2815 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2816 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 8498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 8504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 665:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 666:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 667:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 668:
#line 2821 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 669:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 8534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 8540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 671:
#line 2824 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 8546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2825 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 8552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2837 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8563 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2851 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8569 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2852 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8575 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2853 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2857 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8587 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2858 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8593 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 691:
#line 2867 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8599 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 692:
#line 2868 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8605 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2869 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8611 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8617 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8623 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8629 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 697:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 698:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8641 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2875 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2876 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2899 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2900 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2901 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 705:
#line 2902 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2903 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2904 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2905 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2906 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2907 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2908 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2909 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2910 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2911 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2912 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2913 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2914 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2915 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2916 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2917 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2918 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2920 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2921 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2924 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2925 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2927 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 732:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 733:
#line 2930 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2931 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2932 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2933 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 8884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2935 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2936 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 8902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2948 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8913 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2958 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 8919 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2959 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8925 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 8931 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2969 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 8937 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2973 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2982 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 755:
#line 3005 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 756:
#line 3009 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3023 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 8990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3029 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 764:
#line 3032 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 9002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 765:
#line 3035 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 9008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 766:
#line 3040 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 9014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 767:
#line 3043 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 9020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3048 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 9026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3051 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 9032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3055 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 9038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3058 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 9046 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 9052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 773:
#line 3062 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 9058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 774:
#line 3063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 9064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 9070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 9076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 9082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 9088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 9094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3074 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 9103 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3083 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 9113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3088 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 9119 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 785:
#line 3089 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 9125 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3096 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 9137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3107 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 9143 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3108 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9149 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3108 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 9155 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3109 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3109 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 9167 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 794:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 9177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3115 "cf-parse.y" /* yacc.c:1646  */
    { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 9183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3128 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = -1;
  RADV_IFACE->route_linger_time = -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 9209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3151 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 9215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 801:
#line 3152 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 9221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 802:
#line 3153 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 9227 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 803:
#line 3154 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 9233 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 804:
#line 3155 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 9239 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3156 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 9245 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 806:
#line 3157 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 9251 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3158 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 9257 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 808:
#line 3159 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 9263 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 809:
#line 3160 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3165 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3169 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 9288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 812:
#line 3170 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 9294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3171 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 9300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3172 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 9306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3173 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 9312 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3174 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9318 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3174 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 9324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3175 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 9330 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3175 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 9336 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3176 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 9342 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3177 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 9348 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3181 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 9354 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3182 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 9360 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3183 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 9366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3186 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 9407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 3239 "cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 9422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 3251 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 9428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 3252 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 9434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 3253 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 9440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 3254 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9449 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 3258 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 3265 "cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 9470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 3289 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 3298 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 3305 "cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 9497 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 3309 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 9513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 3333 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 9528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 854:
#line 3345 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 857:
#line 3352 "cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 9543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 858:
#line 3356 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 9559 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 863:
#line 3380 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 9565 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 864:
#line 3381 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 9571 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 865:
#line 3385 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = -1; }
#line 9577 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 866:
#line 3386 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 9583 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 867:
#line 3394 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 9598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 869:
#line 3407 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 9604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 870:
#line 3408 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 9610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 871:
#line 3409 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 9616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 876:
#line 3423 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 9642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 877:
#line 3446 "cf-parse.y" /* yacc.c:1646  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 9675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 878:
#line 3476 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 9681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 879:
#line 3477 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 9687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 880:
#line 3478 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 9693 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 881:
#line 3479 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 9699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 882:
#line 3480 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 9705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 883:
#line 3481 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9711 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 884:
#line 3482 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 9720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 885:
#line 3486 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 9726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 886:
#line 3487 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 9732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 887:
#line 3488 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 9738 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 888:
#line 3489 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 9744 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 889:
#line 3490 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 9750 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 890:
#line 3491 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 9756 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 891:
#line 3492 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 9762 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 892:
#line 3493 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9768 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 893:
#line 3494 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 9774 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 894:
#line 3495 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9780 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3496 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 9786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3497 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 9792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 897:
#line 3498 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 9798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 898:
#line 3499 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->ttl_security = 2; }
#line 9804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3500 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 9810 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 900:
#line 3501 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 901:
#line 3502 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 9822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 902:
#line 3503 "cf-parse.y" /* yacc.c:1646  */
    { rip_check_auth(); }
#line 9828 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 903:
#line 3507 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 9834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 904:
#line 3508 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 9840 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 905:
#line 3509 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9846 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 906:
#line 3510 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9852 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3531 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9858 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3534 "cf-parse.y" /* yacc.c:1646  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9864 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3540 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 9873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3549 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 9879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 918:
#line 3550 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3551 "cf-parse.y" /* yacc.c:1646  */
    { static_route_finish(); }
#line 9891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3554 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3564 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3573 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3577 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3583 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 9940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3584 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3588 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3593 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9967 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3599 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3602 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9984 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3607 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 931:
#line 3608 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 932:
#line 3609 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 10002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 933:
#line 3610 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 10008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 934:
#line 3611 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 10014 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 935:
#line 3615 "cf-parse.y" /* yacc.c:1646  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 10020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 936:
#line 3616 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 10026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 941:
#line 3631 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 10032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 942:
#line 3637 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
}
#line 10041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 948:
#line 3657 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 10056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 949:
#line 3670 "cf-parse.y" /* yacc.c:1646  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
#line 10082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 951:
#line 3694 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 952:
#line 3695 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 10094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 953:
#line 3696 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
#line 10100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 954:
#line 3697 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->update_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
#line 10106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 955:
#line 3698 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 10112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 956:
#line 3699 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 10118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 957:
#line 3700 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 10124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 958:
#line 3701 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 959:
#line 3702 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 10136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 960:
#line 3703 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 10142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 961:
#line 3704 "cf-parse.y" /* yacc.c:1646  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 10148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 967:
#line 3725 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 968:
#line 3728 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 969:
#line 3731 "cf-parse.y" /* yacc.c:1646  */
    { babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 10166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1043:
#line 3739 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 10172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1045:
#line 3739 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 10178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1058:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 10184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1059:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 10190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1060:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 10196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1061:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 10202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1062:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 10208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1063:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 10214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1064:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 10220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1065:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 10226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1066:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 10232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1067:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 10238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1068:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 10244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1069:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 10250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1070:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 10256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1071:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 10262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1072:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 10268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1073:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 10274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1074:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 10280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1075:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 10286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1076:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 10292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1077:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 10298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1078:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 10304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1079:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 10310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1080:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 10316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1081:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 10322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1082:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 10328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1083:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 10334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1084:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 10340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1085:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 10346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1086:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 10352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1087:
#line 3742 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 10358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1088:
#line 3743 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 10364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1089:
#line 3743 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 10370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1090:
#line 3744 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 10376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1091:
#line 3745 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 10382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1092:
#line 3746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 10388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1093:
#line 3747 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 10394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1094:
#line 3748 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 10400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1095:
#line 3749 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 10406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1096:
#line 3750 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 10412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1097:
#line 3751 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 10418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1098:
#line 3752 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 10424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1099:
#line 3753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 10430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1100:
#line 3754 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 10436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1101:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 10442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1102:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 10448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1103:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 10454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1104:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 10460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1105:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 10466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1106:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 10472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1107:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 10478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1108:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 10484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1109:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 10490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 1110:
#line 3755 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
#line 10496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 10500 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3757 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

